C    Odeidon, a program for structural identification of ODEs
C    Copyright (C) 2011 Peter Gennemark, Dag Wedelin
C
C    This program is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with this program.  If not, see <http://www.gnu.org/licenses/>.

C    Contact: Peter Gennemark, Dag Wedelin
C             www.odeidentification.org
C
C
C
C     Read type of problem
      program main
      implicit none

      character*30 pname 
      double precision formatVersion
      integer u
      parameter (u=20)
      integer kode,k2,iostat,pos,posnext,idummy
      character cline*1000,clinetmp*1000,temp*50,command*50
      character temp2*50
      integer debug

      debug=1

      
C     OPEN(u, FILE=pname, STATUS='UNKNOWN') 
C     110   read(20, '(BN,A)', iostat=kode,end=9999) cline 
 
 110  read(*, '(BN,A)', iostat=kode,end=9999) cline 
      if (kode .ne. 0) then
         if (debug.gt.0) write(*,*) 'main, failure'
         stop 
      endif
      if (debug.gt.1) write(*,*) cline(1:50),'...'
      

      pos=1
      call nextString(cline,pos,posnext,command)
      pos=posnext
      if (debug.gt.1) write(*,*) command
      


C     ======================================================== //
      if (command.eq.'//') then
         if (debug.gt.1) write(*,*) 'main, reading, comment '
     $        ,cline(1:50)

C     ======================================================== empty
      elseif (pos.gt.1000) then
         if (debug.gt.1) write(*,*) 'main, reading, empty line '
     $        ,cline(1:50)


C     ======================================================== format
      elseif (command.eq.'format') then
         if (debug.gt.1) write(*,*) 'main, reading, format '
     $        ,cline(1:50)
         call nextString(cline,pos,posnext,temp2) !verison
         pos=posnext
         call nextString(cline,pos,posnext,temp2) !=
         pos=posnext
         call nextDouble(cline,pos,posnext,formatVersion)
         if (formatVersion.eq.1.0) then
            
         else
            write(*,*) 'main, reading, format verison ',formatVersion
     $           ,' not supported'
            stop
         endif



         
C     ======================================================== begin (name)
      else if (command.eq.'begin') then
         call nextString(cline,pos,posnext,temp2) !problem
         pos=posnext
         call nextString(cline,pos,posnext,temp)
         pos=posnext
         if (debug.gt.0) write(*,*) 'Problem name ',temp
         pname=temp
         
  

C     ======================================================== type
      else if (command.eq.'type') then
         call nextString(cline,pos,posnext,temp2) !=
         pos=posnext
         call nextString(cline,pos,posnext,temp)
         if (temp.eq.'reactionKinetics') then
            call alg(pname,formatVersion,debug)
            stop
         elseif (temp.eq.'SSystem') then
            call alg(pname,formatVersion,debug)
            stop
         else 
            write(*,*) 'main, reading, illegal problem type',temp
            stop
         endif

C     ======================================================== date
      else if (command.eq.'date') then
         call nextString(cline,pos,posnext,temp2) !=
         pos=posnext
         call nextString(cline,pos,posnext,temp)
         pos=posnext
         if (debug.gt.0) write(*,*) 'Date  ',temp
         call nextString(cline,pos,posnext,temp)
         pos=posnext
         if (debug.gt.0) write(*,*) 'Time  ',temp

C     ======================================================== url
      else if (command.eq.'url') then
         call nextString(cline,pos,posnext,temp2) !=
         pos=posnext
         call nextString(cline,pos,posnext,temp)
         pos=posnext
         if (debug.gt.0) write(*,*) 'url  ',temp
        
      endif


      goto 110                  ! Read next command

 9999 if (debug.gt.1) write(*,*)'End of input'
      close(u)
      end
