C     This file was automatically generated by GenerateFortran.generate()
C     on Wed Feb 06 14:05:22 CET 2013
C
C    Odeidon, a program for structural identification of ODEs
C    Copyright (C) 2011 Peter Gennemark, Dag Wedelin
C
C    This program is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with this program.  If not, see <http://www.gnu.org/licenses/>.

C    Contact: Peter Gennemark, Dag Wedelin
C             www.odeidentification.org
C
C
C


      subroutine alg(pname,formatVersion,debug)
      implicit none
      integer maxexp,maxvar,maxpts,maxr,maxv,maxk
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)
      integer maxtypes
      parameter (maxtypes=2)
      integer nexp,nvare,npts(maxexp),npts2
      double precision edata(maxexp,maxvar+1,2*maxpts) 
      double precision edata2(maxexp,maxvar+1,2*maxpts)   
      integer spline(maxexp,maxvar) ! 0=linear interpolation, 1=cubic smoothing spline 
      integer spline2(maxexp,maxvar) ! 0=linear interpolation, 1=cubic smoothing spline 


C     ------ MODEL ------
      integer modtype(maxvar,maxr) 
C     Type of reaction [1...maxr] for variable [1...maxvar]
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=2: Lower bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=3: Upper bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      integer modn(maxvar) 
C     Number of reactions for variable [1...maxvar]
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      logical dependent(maxvar) 
C     Which variables are dependent

C     ------ TEMP MODEL ------
      integer tmodtype(maxvar,maxr) 
C     Type of reaction [1...maxr] for variable [1...maxvar]
      double precision tmodk(maxvar,maxr,maxk,3) 
C     Last index=1: Parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=2: Lower bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=3: Upper bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
      double precision tmodkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      integer tmodn(maxvar) 
C     Number of reactions for variable [1...maxvar]
      integer tmodv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]


C     ------ TEMP MODEL 2 ------
      integer t2modtype(maxvar,maxr) 
C     Type of reaction [1...maxr] for variable [1...maxvar]
      double precision t2modk(maxvar,maxr,maxk,3) 
C     Last index=1: Parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=2: Lower bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=3: Upper bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
      double precision t2modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      integer t2modn(maxvar) 
C     Number of reactions for variable [1...maxvar]
      integer t2modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]

      integer nvar,N,NN

      integer getNumberOfReactionTypes,getKsOfType,getVsOfType,kn,ireact

      logical restart
      logical noisedone         ! one extra iteration with estimated init conc if noisy data


      integer i,ij,icho,iter
      integer isucc,iv
      double precision s ! smoothing parameter
      double precision errcur(maxvar),errtem,errloc,res,error,err0,temp
      

      character*30 pname,fname 
      double precision formatVersion

      logical didAdd(maxvar)    ! true if we added a reaction in previous iteration for this variable
C     When k for reaction types 1..maxtypes is below this value => try to remove because it is weak

      integer noiselevel


      double precision TMPR(maxexp*maxvar*maxpts)
      double precision TMPRES(maxexp*maxvar*maxpts) 

   
      integer maxirl            ! max rows in rlist
      integer irl(maxvar)               ! no of active rows in rlist
      parameter (maxirl=1000)
      integer rlisttype(maxvar,maxirl)   ! Table of possible reaction types to add
      integer rlistv(maxvar,maxirl,maxv)   ! Table of variables associated to each reaction
      double precision rlistk(maxvar,maxirl,maxk,2) ! Table of parameter bounds associated to each reaction
      character*30 ename 

C     g77
      !character*9 date0,date1
      !character*8 time0,time1
      !real*4 secnds             ! an intrinsic timer function in G77 
      !real*4 t,t0,t1

C     gfortran
      character(8)  :: date0,date1
      character(10) :: time0,time1
      character(5)  :: zone0,zone1
      integer,dimension(8) :: values0,values1
      real(4) :: t,t0,t1,secnds 





      integer debug,ivar,iexp,j
      
      logical useip(maxvar)     ! use ip data or sim data in simulate single
      logical useipold(maxvar) 
      logical findss            ! Find steady state before producing simulated data
      logical constval

                ! errsettings
      double precision stdev(maxexp,maxvar,maxpts), lambda

      logical initconc          ! T if init conc consider as parameter, ow F


      integer RAND(2) ! Random starts in estvar
      
      integer idummy
      logical var(maxvar)
      
      integer SEED

      common/simulg/var,idummy 
      common/mydata/edata,spline,npts,nexp,nvar,nvare
      common/mydata2/edata2,npts2,useip
      common/mydata3/modk,modkinit,modn,modv,modtype,dependent
      common/errsettings/stdev,lambda
      common/myinitconc/initconc
      common/myrandomstarts/RAND
      common/mysmoothingpara/s
      common/myrandomseed/SEED
      common/mymodelspace/rlistk,rlistv,rlisttype,irl
       
      noisedone=.false.
      initconc=.false.
 
      write(*,*) 'Read problem'
      call readProblem(pname,debug-1)                              
      call zufalli(SEED)          ! 0 < seed <31328
      
 
C     SET METHOD PARAMETERS
      do 34 iexp=1,nexp
         do 33 j=1,nvar
            if (dependent(j)) then ! 0=lin interpol, 1=smooth spline
               spline(iexp,j)=1 
            else
               spline(iexp,j)=0         
            endif 
            constval=.true.     ! if constant time-series, set spline to 0
            do 31 ij=1,(npts(iexp)-1)
               if(edata(iexp,j+1,ij).ne.edata(iexp,j+1,ij+1)) then 
                  constval=.false.
               endif
 31         enddo
            if (constval) then 
               spline(iexp,j)=0 
               if (dependent(j)) write (*,5080) 'spline(',iexp,',',j
     $              ,')=0' 
 5080          format(A,I3,A,I3,A)
            endif
 33      enddo
 34   enddo
C     Should we consider estimation of initial parameters?
C     If so, set noiselevel>0, ow set noiselevel=0
      noiselevel=0
      do 650 i= 1, nexp  
         do 640 j=1,nvar
            if (modkinit(i,j,2).ne.modkinit(i,j,3)) noiselevel=1
 640     enddo
 650  enddo





      if (debug.gt.0) then
         write(*,*) '======METHOD PARAMETERS==========='
         write(*,*) 'Smoothing parameter (s) = ',s
         write(*,*) 'RAND(1 and 2) = ',RAND(1),RAND(2) 
         write(*,*) 'RandomSEED = ',SEED
         write(*,*) '======PROBLEM====================='
         write(*,*) 'Name=',pname
         write(*,*) 'Noise level=',noiselevel
         write(*,*) 'Error function, lambda=',lambda
         write(*,*) 'dependent(:)=',(dependent(i),i=1,nvar)
         write(*,4000) 'spline(1,:)=',(spline(1,i),i=1,nvar)
 4000    format(A,30I2)
         call printmodel(maxvar,maxr,maxv,maxk,nvar,
     *        modtype,modk,modn,modv,dependent)
         call printdata2(edata,spline,
     *        maxexp,maxvar,maxpts,nexp,nvare,npts)
         call printmodkinit(maxvar,maxexp,nvar,nexp,
     $        modkinit,dependent,1)
         call printmodkinit(maxvar,maxexp,nvar,nexp,
     $        modkinit,dependent,2)
         call printmodkinit(maxvar,maxexp,nvar,nexp,
     $        modkinit,dependent,3)
      endif
      if (debug.gt.0.and.noiselevel.gt.0)  then 
         write(*,*) 'Init values will be considered as parameters'
      else if (debug.gt.0) then
         write(*,*) 'Init values will NOT be considered as parameters'
      endif

      call smoothdata(s,debug)
      
      

      do 355 i=1,nvar
         didAdd(i)=.true. 
         useip(i)=.true.  
 355  continue 
      
      call readdata2(edata,edata2,spline2,
     *     nexp,nvare,npts,npts2,
     *     nvar,
     *     debug-1)        ! give printing opportunity 
      
      if (debug.gt.0) then 
         write(*,*) 'Update edata2.'
      endif
      
C     g77
      !call date(date0)
      !call time(time0)
      !write(*,*) 'startDateTime = ',date0,' ',time0
C     gfortran
      call date_and_time(date0,time0,zone0,values0)
      write(*,*) 'startDateTime = ',date0,' ',time0

      t0= secnds(0.0)




C     --------------------------------------------------------
C     Is this a parameter estimation problem (fixed structure)
C     --------------------------------------------------------
      temp=0
      do 368 ivar=1,nvar
         if (dependent(ivar)) then
            temp=temp+irl(ivar) 
         endif
 368  enddo
      if (temp.eq.0) then       ! No model space -> parameter estimation only
         call alg_paraest(noiselevel,1,error,debug)
         goto 2000              ! print out result and then terminate
      endif
C     --------------------------------------------------------




      
      call estmakeedata2(errtem,spline2) 



C ----------------------------------------------------------------------
C                          MAIN LOOP STARTS
C ----------------------------------------------------------------------
      write(*,*) '==== SEARCH STARTS (initial parameters) ===='
      iter=0
      

 300  continue                  ! ------------------------- DO WHILE  
      
      iter=iter+1
      if (debug.gt.0) then    
         !t = secnds(0.0)
         write(*,*) '================================================'
         write(*,*) '====== Iter ',iter
         write(*,*) '====== useip',(useip(ij),ij=1,nvar)
         write(*,*) '====== didadd=',(didadd(ij),ij=1,nvar)
         write(*,*) '================================================'
         call printmodel(maxvar,maxr,maxv,maxk,nvar,
     *        modtype,modk,modn,modv,dependent) 
      endif
      
      do 410 ivar=1,nvar  
         if (dependent(ivar)) then 
            if (iter.eq.1) then
               call estvar12(ivar,errcur(ivar))
               if (debug.gt.1) call printvar(maxvar,maxr,maxv,maxk,nvar,
     *              modtype,modk,modn,modv,dependent,ivar)
            endif
            if (debug.gt.0) write(*,5500) '===  ivar=',ivar,' errcur('
     $           ,ivar,')=',errcur(ivar)
 5500       format(A,I3,A,I3,A,D10.3)
         endif
 410  continue
      
      restart=.false.
C     ----------------------------------------- try all variables
      do 600 ivar=1,nvar        ! find structure for all variables
         if (.not.dependent(ivar)) goto 500
         
         if (debug.gt.0) then 
            write(*,5000) '######### Consider variable ',ivar,
     $           ' errcur=' ,errcur(ivar) 
 5000       format(A,I3,A,D10.3)
            call printvar(maxvar,maxr,maxv,maxk,nvar,
     *           modtype,modk,modn,modv,dependent,ivar)
         endif
         errtem=errcur(ivar)   
         if (.not.(useip(ivar).and.useipold(ivar)))then
            call estvar(ivar,errcur(ivar),2,.true.)
            if (debug.gt.0) write(*,*) 'estvar, errcur='
     $           ,errcur(ivar)
            call estvarrm(ivar,errcur(ivar),errcur,errtem,
     *           .false.,0,2,debug)
            if (debug.gt.0) write(*,5600) 'estvarrm, e=',errtem
     $           ,' errcur=',errcur(ivar)
 5600       format(A,D10.3,A,D10.3)
         endif
!     OLD VERISON:
         !if (errtem.lt.errcur(ivar)) then ! we did modify the structure
!     UPDATED 2010-09-21:
         if (errtem.lt.errcur(ivar)*0.999) then ! we did modify the structure
            errcur(ivar)=errtem 
            call estmakeedata2(errtem,spline2) ! global error
            restart=.true.
         endif        
         
         if (.not.didAdd(ivar).and.useip(ivar).and.useipold(ivar))
     $        then
            if (debug.gt.0)  write(*,*) 'skipping...'
            goto 500
         endif
C     ----------------------------------------- Consider this variable
         
         useipold(ivar)=useip(ivar)
         errloc=errcur(ivar)    ! local best error in loop
         
         call icopy(maxvar*maxr,modtype,1,t2modtype,1) ! Make temp copy     
         call dcopy(maxvar*maxr*maxk*3,modk,1,t2modk,1) 
         call dcopy(maxvar*maxexp*3,modkinit,1,t2modkinit,1)
         call icopy(maxvar,modn,1,t2modn,1)
         call icopy(maxvar*maxr*maxv,modv,1,t2modv,1)
         
C     ----------------------------------------- try all reactions
         do 380 i=1,irl(ivar)   ! for all test reactions 
            call icopy(maxvar*maxr,t2modtype,1,modtype,1) ! Reset
            call dcopy(maxvar*maxr*maxk*3,t2modk,1,modk,1)
            call dcopy(maxvar*maxexp*3,t2modkinit,1,modkinit,1
     $           )
            call icopy(maxvar,t2modn,1,modn,1)
            call icopy(maxvar*maxr*maxv,t2modv,1,modv,1)
            
            call addr(nvar,
     *           ivar,
     *           rlisttype,rlistv,rlistk,maxirl,i, ! i is row to consider
     *           debug,  
     *           isucc)
            if (isucc.lt.0) goto 360 ! skip rest of outer loop
            
            call estvarrm(ivar,errloc,errcur,errtem,
     *           .true.,0,1,debug)
            
            if (errtem.lt.errcur(ivar).and.
     *           errtem.lt.errloc) then
               errloc=errtem  
               call icopy(maxvar*maxr,modtype,1,tmodtype,1) ! make temp copy
               call dcopy(maxvar*maxr*maxk*3,modk,1,tmodk,1)
               call dcopy(maxvar*maxexp*3,modkinit,1,tmodkinit
     $              ,1)
               call icopy(maxvar,modn,1,tmodn,1)
               call icopy(maxvar*maxr*maxv,modv,1,tmodv,1)
            endif
 360        continue            ! gone to when continuing to next test reaction
 380     continue               ! end try all test reactions

  
C     ----------------------------------------- try all variables (GMA)
         do 480 j=1,modn(ivar)  ! for all terms
            do 490 i=1,nvar  
               !if(dependent(i)) then
                  call icopy(maxvar*maxr,t2modtype,1,modtype,1) ! Reset
                  call dcopy(maxvar*maxr*maxk*3,t2modk,1,modk,1)
                  call dcopy(maxvar*maxexp*3,t2modkinit,1,modkinit,1
     $                 )
                  call icopy(maxvar,t2modn,1,modn,1)
                  call icopy(maxvar*maxr*maxv,t2modv,1,modv,1)
                  
                  call addv(nvar,
     *                 ivar,
     *                 rlisttype,rlistv,rlistk,maxirl,i,j, ! i is variable, j is term
     *                 debug,  
     *                 isucc)
                  if (isucc.lt.0) goto 460 ! skip rest of outer loop
                  
                  call estvarrm(ivar,errloc,errcur,errtem,
     *                 .false.,j,1,debug)
                  
                  if (errtem.lt.errcur(ivar).and.
     *                 errtem.lt.errloc) then
                     errloc=errtem  
                     call icopy(maxvar*maxr,modtype,1,tmodtype,1) ! make temp copy
                     call dcopy(maxvar*maxr*maxk*3,modk,1,tmodk,1)
                     call dcopy(maxvar*maxexp*3,modkinit,1,tmodkinit
     $                    ,1)
                     call icopy(maxvar,modn,1,tmodn,1)
                     call icopy(maxvar*maxr*maxv,modv,1,tmodv,1)
                  endif
 460              continue
               !endif            
 490        continue            ! gone to when continuing to next variable
 480     continue               ! end try all terms
         
  
         didAdd(ivar)=.false.
         if (errloc.lt.errcur(ivar)) then ! success, restart 
            call icopy(maxvar*maxr,tmodtype,1,modtype,1) ! set best model
            call dcopy(maxvar*maxr*maxk*3,tmodk,1,modk,1)
            call dcopy(maxvar*maxexp*3,tmodkinit,1,modkinit,1)
            call icopy(maxvar,tmodn,1,modn,1)
            call icopy(maxvar*maxr*maxv,tmodv,1,modv,1)
            errcur(ivar)=errloc
            restart=.true.
            didAdd(ivar)=.true.
            errtem=errcur(ivar)
            call estvarrm(ivar,errcur(ivar),errcur,errtem,
     *           .false.,0,2,debug)
            errcur(ivar)=errtem
            if (debug.gt.0) write(*,5600) 'tune e=',errtem
     $           ,' errcur=',errcur(ivar)
            call estmakeedata2(errtem,spline2)            
         else                   ! No reaction was added, reset
            call icopy(maxvar*maxr,t2modtype,1,modtype,1) 
            call dcopy(maxvar*maxr*maxk*3,t2modk,1,modk,1)
            call dcopy(maxvar*maxexp*3,t2modkinit,1,modkinit,1
     $           )
            call icopy(maxvar,t2modn,1,modn,1)
            call icopy(maxvar*maxr*maxv,t2modv,1,modv,1)
         endif
 500     continue               ! Gone to when skipping to new variable
 600  continue                  ! Loop all variables
      
      

      if (restart) goto 300
      if (debug.gt.0) write(*,*) '==== SEARCH ENDS ===='
      if (noiselevel.gt.0) initconc=.true.

      if (debug.gt.0) write(*,*) 'Call estgeneral'
      call estgeneral(error,.true.)
      if (debug.gt.0) then
         call printmodel(maxvar,maxr,maxv,maxk,nvar,
     *        modtype,modk,modn,modv,dependent) 
         write(*,*) 'error=',error
         if (noiselevel.gt.0) call printmodkinit(maxvar,maxexp,nvar,nexp
     $        ,modkinit,dependent,1)
      endif
      
      
      if (.not.noisedone.and.noiselevel.gt.0) then ! Final round with estimated init conc
         if (debug.gt.0) write(*,*)'SEARCH CONTINUES new init conc'
         noisedone=.true.
         do 459 i=1,nvar
            didAdd(i)=.true.
 459     continue 
         goto 300
      endif

      if (debug.gt.0) write(*,*) 'Tune, initconc=',initconc
      call tunewithest(error,debug)

      
      if (debug.gt.0) write(*,*) 'call estgeneral'
      call estgeneral(error,.true.)
      if (debug.gt.0) then 
         call printmodel(maxvar,maxr,maxv,maxk,nvar,
     *        modtype,modk,modn,modv,dependent) 
         write(*,*) 'error=',error
         if (noiselevel.gt.0) call printmodkinit(maxvar,maxexp,nvar,nexp
     $        ,modkinit,dependent,1)
      endif


C     added 090306  
      do 655 i=1,nvar 
         useip(i)=.true.  
 655  continue        
      call icopy(maxvar*maxr,modtype,1,tmodtype,1) ! Make temp copy     
      call dcopy(maxvar*maxr*maxk*3,modk,1,tmodk,1) 
      call dcopy(maxvar*maxexp*3,modkinit,1,tmodkinit,1)
      call icopy(maxvar,modn,1,tmodn,1)
      call icopy(maxvar*maxr*maxv,modv,1,tmodv,1)
      do 610 ivar=1,nvar  
         if (dependent(ivar)) then 
            call estvar12(ivar,errcur(ivar))
         endif
 610  continue
      call estgeneral(errtem,.true.) 
      if (debug.gt.0) then 
         write(*,*) 'BEGIN REDO ESTIMATION FROM SCRATCH'
         call printmodel(maxvar,maxr,maxv,maxk,nvar,
     *        modtype,modk,modn,modv,dependent) 
         write(*,*) 'error=',errtem
         if (noiselevel.gt.0) call printmodkinit(maxvar,maxexp,nvar,nexp
     $        ,modkinit,dependent,1)
         write(*,*) 'END REDO ESTIMATION FROM SCRATCH'
      endif
      if (error.lt.errtem) then
         call icopy(maxvar*maxr,tmodtype,1,modtype,1) ! Make temp copy     
         call dcopy(maxvar*maxr*maxk*3,tmodk,1,modk,1) 
         call dcopy(maxvar*maxexp*3,tmodkinit,1,modkinit,1)
         call icopy(maxvar,tmodn,1,modn,1)
         call icopy(maxvar*maxr*maxv,tmodv,1,modv,1)
      else
         error=errtem
      endif
C     added 090306



      

      


 2000 continue                  ! Parameter estimation only continues here

      
C     g77
      !call date(date1)
      !call time(time1)
C     gfortran
      call date_and_time(date1,time1,zone1,values1)
    
      t1 = secnds(0.0)
      t = t1-t0



                                
C     what is -L? Calculate lambda*K
      kn=0
      do 50, ivar=1,nvar
         do 40, ireact=1,modn(ivar)
            kn=kn+getKsOfType(modtype(ivar,ireact))
 40      continue
 50   continue


      write(*,*) '======== RESULT ==========' 
      write(*,*) 'model obtained:'
      call printmodel(maxvar,maxr,maxv,maxk,nvar,
     *     modtype,modk,modn,modv,dependent) 
      if (initconc) call printmodkinit(maxvar,maxexp,nvar,nexp,
     *     modkinit,dependent,1)


      write(*,*) 'startDateTime = ',date0,' ',time0
      write(*,*) 'endDateTime = ',date1,' ',time1
      write(*,*) 'StartTime = ',t0
      write(*,*) 'CurrentTime = ',t1
      write(*,*) 'FinalRes = ',error-lambda*kn
      write(*,*) 'FinalError = ',error
      write(*,*) 't_sec = ',t

     
      call savemodel(nvar,nexp,pname,fname,error,(error-lambda*kn))
      if (debug.gt.1) write(*,*) 'Model saved in ',fname


      end
      
      
      




