C     This file was automatically generated by GenerateFortran.generate()
C     on Wed Feb 06 14:05:22 CET 2013
C
C    Odeidon, a program for structural identification of ODEs
C    Copyright (C) 2011 Peter Gennemark, Dag Wedelin
C
C    This program is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with this program.  If not, see <http://www.gnu.org/licenses/>.

C    Contact: Peter Gennemark, Dag Wedelin
C             www.odeidentification.org
C
C
C
C     For ivar, call estvar for both type 1 and 2.
C     return error using errvar
C     type=1, derivative approach
C     type=2, simulate single
C     initg fixed to T
      subroutine estvar12(ivar,error)
      implicit none 

      double precision error
      integer ivar

      integer maxexp,maxvar,maxpts,maxr,maxv,maxk
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)

      integer nexp,nvare,npts(maxexp),npts2
      double precision edata(maxexp,maxvar+1,2*maxpts)
      integer spline(maxexp,maxvar) ! 0=linear interpolation, 1=cubic smoothing spline 
          
      integer nvar
C     ------ MODEL ------
      integer modtype(maxvar,maxr) 
C     Type of reaction [1...maxr] for variable [1...maxvar]
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=2: Lower bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=3: Upper bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      integer modn(maxvar) 
C     Number of reactions for variable [1...maxvar]
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      logical dependent(maxvar) 
C     Which variables are dependent

      DOUBLE PRECISION X(25)

      integer ipara,ireact,j,jj,getKsOfType
      integer debug
      
      common/mydata/edata,spline,npts,nexp,nvar,nvare
      common/mydata3/modk,modkinit,modn,modv,modtype,dependent

      debug=0

      ipara=1                   ! BEGIN Model to X
      do 320 ireact=1,modn(ivar)
         do 310 j=1,getKsOfType(modtype(ivar,ireact))
            if (ipara.gt.25) then ! ipara too large
               write(*,*) 'estvar12, ivar=',ivar
     $              ,' size of X=25 is too small'
               stop
            endif
            X(ipara)=modk(ivar,ireact,j,1) 
            ipara=ipara+1
 310     continue
 320  continue                  ! END Model to X



      call estvar(ivar,error,1,.true.)
      if (error.gt.1.d200) then
         if (debug.gt.0) write(*,*) 'estvar12, reset parameters.'
         if (debug.gt.1) call printvar(maxvar,maxr,maxv
     $        ,maxk,nvar,modtype,modk,modn,modv,dependent
     $        ,ivar)
         ipara=1                ! BEGIN X to model
         do 810 ireact=1,modn(ivar)
            do 800 jj=1,getKsOfType(modtype(ivar,ireact))
               modk(ivar,ireact,jj,1)=X(ipara)
               ipara=ipara+1
 800        continue
 810     continue               ! END X to model
      endif
     
      call estvar(ivar,error,2,.true.)
      if (debug.gt.1) then 
         write(*,*) 'estvar12, e=' ,error
         if (debug.gt.2) call printvar(maxvar,maxr,maxv
     $        ,maxk,nvar,modtype,modk,modn,modv,dependent
     $        ,ivar)
      endif
      
     
      end






C     Estimate parameters for ONE variable ivar
C     call dn2gb for constrained least-squares
C     return error using errvar
C     type=1, derivative approach
C     type=2, simulate single
C     initg, T if the current parameters in the model serve as first guess
C             and subsequent guesses are randomly chosen
C            F if all guesses are randomly chosen
      subroutine estvar(ivar,error,type,initg)

      implicit none

      double precision error
      integer ivar,type

      integer maxexp,maxvar,maxpts,maxr,maxv,maxk
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)

      integer nexp,nvare,npts(maxexp),npts2
      double precision edata(maxexp,maxvar+1,2*maxpts)
      double precision edata2(maxexp,maxvar+1,2*maxpts)
      logical useip(maxvar)
      integer spline(maxexp,maxvar) ! 0=linear interpolation, 1=cubic smoothing spline 
      
      integer nvar
C     ------ MODEL ------
      integer modtype(maxvar,maxr) 
C     Type of reaction [1...maxr] for variable [1...maxvar]
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=2: Lower bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=3: Upper bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      integer modn(maxvar) 
C     Number of reactions for variable [1...maxvar]
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      logical dependent(maxvar) 
C     Which variables are dependent


      integer iter,ireact,iLV,iLIV,ipara,iii,iuni,j,i,iexp
      integer getKsOfType

C     DN2GB
      INTEGER P, LIV, LV, UI(1),NF,N,LR
      INTEGER LTY(1)
C     LTY - additional integer inputs (IN)
C     LTY(1) - the variable to consider
      DOUBLE PRECISION B(2,25), TY(1), X(25), XOPT(25) 
      EXTERNAL DUMMY, JACOB2, FUN2, JACOB3, FUN3
      parameter(LIV=182,LV=3284,LR=52) ! automatically set
      double precision R(LR),RES
      INTEGER IV(LIV)
      DOUBLE PRECISION V(LV)
      double precision RTMP(maxexp*maxpts),RESTMP(maxexp*maxpts)
      

      integer maxuni,nuni
      parameter(maxuni=30000)  ! RANDOM STARTS IN LEAST_SQUARES
      DOUBLE PRECISION resopt,uni(maxuni)
      logical initg,initglocal
      

!     LIV = 82 + 4*P
!     LV = 105 + P*(N + 2*P + 21) + 2*N 
      integer debug
      
      integer RAND(2) ! Random starts in estvar type 1 and 2
      
      common/mydata/edata,spline,npts,nexp,nvar,nvare
      common/mydata2/edata2,npts2,useip
      common/mydata3/modk,modkinit,modn,modv,modtype,dependent
      common/myrandomstarts/RAND
      common/myB/B ! communicates with fun2

      debug=0
      initglocal=initg
      if (type.lt.1.or.type.gt.2) then
         write(*,*) 'estvar, illegal type=',type
         stop
      endif

      P=0
      N=0
      do 5, ireact=1,modn(ivar)
         P=P+getKsOfType(modtype(ivar,ireact))
 5    continue
      if (dependent(ivar)) then
         if (type.eq.1) then
            do 6, iexp=1,nexp
               N=N+(npts(iexp)-1)
 6          continue
         else
            do 7, iexp=1,nexp
               N=N+npts(iexp)
 7          continue
         endif
      endif

      if (P.eq.0) then          ! Empty structure
         N=0
         if (dependent(ivar)) then
            do 8, iexp=1,nexp
               N=N+npts(iexp)
 8          continue
         endif
         call errvar(error,RTMP,RESTMP,N,ivar)
         return
      elseif (P.gt.25) then     ! P too large
         write(*,*) 'estvar, ivar=',ivar,' P ',P
     $        ,' > 25. Increase sizes of datastructures',
     *        'NOTE: also in fun2 and fun3!'
         stop
      endif

      nuni=P*RAND(type)
      if (P*RAND(type).gt.maxuni) then
         write(*,*) 'estvar, ivar=',ivar,' P ',P ,' RAND1=',RAND(type)
     $        ,' P*RAND1=',P*RAND(type),'>maxuni=',maxuni
         write(*,*) 'estvar, increase maxuni'
         stop
      endif

      if (debug.gt.0) then 
         write(*,*) 'estvar, ivar=',ivar,' P ',P,' N='
     $        ,N
         if (debug.gt.1) then
            call printvar(maxvar,maxr,maxv,maxk,nvar,
     *           modtype,modk,modn,modv,dependent,ivar)
         endif
      endif
      iLIV = 82 + 4*P
      iLV = 105 + P*(N + 2*P + 21) + 2*N
      if (iLIV.gt.LIV) then
         write(*,*) 'estvar, LIV should be ', iLIV, ' is ',LIV
      endif
      if (iLV.gt.LV) then
         write(*,*) 'estvar, LV should be ', iLV, ' is ',LV
      endif
      if (N.gt.LR) then
         write(*,*) 'estvar, LR should be ', N, ' is ',LR
      endif

      ipara=1                   ! Model to X
      if (dependent(ivar)) then
         do 20 ireact=1,modn(ivar)
            do 10 j=1,getKsOfType(modtype(ivar,ireact))
               X(ipara)=modk(ivar,ireact,j,1) 
               B(1,ipara)=modk(ivar,ireact,j,2)
               B(2,ipara)=modk(ivar,ireact,j,3)
               ipara=ipara+1
 10         continue
 20      continue
      endif
      do 25 J = 1,P
         XOPT(J) = X(J)
 25   enddo
      LTY(1)=ivar
      if (debug.gt.0) then
         write(*,*)'estvar, type:',type
         write(*,*)'estvar, RAND:',RAND(type)
         write(*,*)'estvar, X:',(X(i),i=1,P)
         write(*,*)'estvar, BL:',(B(1,i),i=1,P)
         write(*,*)'estvar, BU:',(B(2,i),i=1,P)
         write(*,*)'estvar, useip:',(useip(i),i=1,nvar)
      endif
      
      call zufall(nuni,uni)
      iuni=1
      resopt=1.D300
            
C     --------------------- MAIN LOOP -----------------
      do 1000 iter=1,RAND(type)
         if (.not.initglocal) then   !     Random init guess 
            DO 70 J = 1,P
               if (iuni.gt.nuni) then
                  write(*,*) 'estvar, iuni=',iuni,', nuni=',nuni
                  stop
               endif

               if (B(1,J).gt.0) then ! uniform distr on log scale.
                  X(J) = exp(log(B(1,J))+(log(B(2,J))-log(B(1,J)))
     $                 *uni(iuni))
               else if (B(2,J).lt.0) then ! uniform distr on log scale.
                  X(J) = -exp(log(abs(B(2,J)))+(log(abs(B(1,J)))
     $                 -log(abs(B(2,J))))*uni(iuni)) 
               else
                  X(J) = B(1,J)+(B(2,J)-B(1,J))*uni(iuni) ! uniform distr.
               endif   
               iuni=iuni+1
 70         enddo
         endif


 

         if (debug.gt.1) then
            if (mod(iter,100).eq.0 )write (*,*) 'estvar, iter ',iter
            if (debug.gt.-1) then
               write (*,*) 'estvar, iter ',iter,'. randX=' 
               write (*,900) (X(J),J=1,P)
            endif
         endif
         do 80 I=1,LIV 
            IV(I)=0
 80      enddo
         do 90 I=1,LV 
            V(I)=0.E0
 90      enddo
         
         
         if (type.eq.1) then 
            call DN2GB(N,P,X, B, FUN2, JACOB2, IV, LIV, LV, V, LTY, TY,
     $           DUMMY) 
            call FUN2(N, P, X, NF, R, ivar, TY, dummy) 

         else


 1          call FUN3(N, P, X, NF, R, LTY, TY, dummy)  
            RES=0.d0
            DO 101 I=1,N 
               RES=RES+R(I)**2
 101        CONTINUE
            if (iter.gt.1.and.RES.gt.25*resopt) then 
               goto 8000
            endif


            call DN2GB(N,P,X, B, FUN3, JACOB3, IV, LIV, LV, V, LTY, TY,
     $           DUMMY)
            call FUN3(N, P, X, NF, R, LTY, TY, dummy)   
         endif

      
         RES=0.d0
         DO 100 I=1,N 
            RES=RES+R(I)**2
 100     CONTINUE
         
            
         if (debug.gt.1) then 
            write (*,900) (X(J),J=1,P)
            write (*,910) RES
            !write (*,920) IV(1)
            !stop
         endif
 900     FORMAT (' estvar x: ',12D10.2)
 910     FORMAT (' estvar, res = ',1PD12.4)
 920     FORMAT (' estvar, output flag =',17X,I6)
         
         if (RES.lt.resopt) then  
            if (debug.gt.0) then
               write(*,*) 'estvar, Best RES=',RES,' (iter ',iter,')'
               write (*,900) (X(J),J=1,P)
            endif
            resopt=RES      
            DO 110 J = 1,P
               XOPT(J) = X(J)
 110        enddo
         endif
      


 8000    continue



         if (initglocal) initglocal=.false.
         
 1000 enddo
      

      ipara=1                   ! XOPT to model
      if (dependent(ivar)) then
         do 220 ireact=1,modn(ivar)
            do 210 j=1,getKsOfType(modtype(ivar,ireact))
               modk(ivar,ireact,j,1)=XOPT(ipara)
               ipara=ipara+1
 210        continue
 220     continue
      endif
      
      if (debug.gt.1) then
         call printvar(maxvar,maxr,maxv,maxk,nvar,
     *        modtype,modk,modn,modv,dependent,ivar)
      endif
      
      
      N=0
      if (dependent(ivar)) then
         do 230, iexp=1,nexp
            N=N+npts(iexp)
 230     continue
      endif
      call errvar(error,RTMP,RESTMP,N,ivar)
      end                       ! End subroutine estvar
      








C     LOCAL SEARCH WITH SIM SINGLE, COMPUTES THE RESIDUAL VECTOR, R = R(X)
C     
C     NOTE: LTY the variable to consider
C
C     N - number of data-points (IN)
C     P - number of parameters (IN)
C     X - parameters, length P (IN)
C     NF - invocation count, see below  (IN/OUT)
C     R - residuals (OUT)
C     LTY - additional integer inputs (IN)
C     LTY(1) - the variable to consider
C     TY - additional real input, here doesn't used (IN)
C     UF - additional function, here doesn't used (IN)
C
C     WHEN CALCR IS CALLED, NF IS THE INVOCATION COUNT
C     FOR CALCR.  IT IS INCLUDED FOR POSSIBLE USE WITH
C     CALCJ.  IF X IS OUT OF BOUNDS (E.G. IF IT WOULD
C     CAUSE OVERFLOW IN COMPUTING R(X)), THEN CALCR SHOULD
C     SET NF TO 0.  THIS WILL CAUSE A SHORTER STEP TO BE
C     ATTEMPTED.   
C
C     DO NOT CHANGE N, P, OR X.
C
      SUBROUTINE FUN3(N, P, X, NF, R, LTY, TY, UF) 

      implicit none
      INTEGER N, P, NF, LTY(1) 
      DOUBLE PRECISION X(P), R(N), TY(1) 
      EXTERNAL UF 


      integer nvar,nexp
      integer maxexp,maxvar,maxpts,maxr,maxv,maxk
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)

      

      
C     ------ MODEL ------
      integer modtype(maxvar,maxr) 
C     Type of reaction [1...maxr] for variable [1...maxvar]
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=2: Lower bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=3: Upper bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      integer modn(maxvar) 
C     Number of reactions for variable [1...maxvar]
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      logical dependent(maxvar) 
C     Which variables are dependent


      integer nvare,npts(maxexp),npts2
      double precision edata(maxexp,maxvar+1,2*maxpts)
      double precision edata2(maxexp,maxvar+1,2*maxpts)
      integer spline(maxexp,maxvar) ! 0=linear interpolation, 1=cubic smoothing spline 
      logical useip(maxvar)

      double precision RDUM(N) ! residuals
      double precision error

      integer debug,ivar,i,jj,ireact,getKsOfType,ipara,ieq


      DOUBLE PRECISION B(2,25)
   
      common/mydata/edata,spline,npts,nexp,nvar,nvare
      common/mydata2/edata2,npts2,useip
      common/mydata3/modk,modkinit,modn,modv,modtype,dependent
      common/myB/B ! communicates with estvar

      do 1 jj=1,P
         if (X(jj).ge.B(1,jj).and.X(jj).le.B(2,jj)) then
         else
            !write(*,*) 'fun2, x out of bounds ', X(jj)
            do 630 ieq=1,N
               R(ieq)=1.d10
 630        enddo
            NF=0
            return
         endif
 1    enddo


      debug=0
    

      ivar=LTY(1) 

      if (debug.gt.0) then 
         write(*,*) 'FUN3, N=',N,' P=',P,' X=',(X(i),i=1,P)
         write(*,*) 'FUN3, LTY=',LTY(1)
      endif

      
C     X to Model
      ipara=1
      if (dependent(ivar)) then
         do 810 ireact=1,modn(ivar)
            do 800 jj=1,getKsOfType(modtype(ivar,ireact))
               modk(ivar,ireact,jj,1)=X(ipara)
               ipara=ipara+1
 800        continue
 810     continue
      endif


      call errvar(error,RDUM,R,N,ivar)

      if (debug.gt.0) then 
         write(*,*) 'eval FUN3, error ',error
         write(*,*) 'R (1..5): ',(R(i),i=1,5)
         call printmodel(maxvar,maxr,maxv,maxk,nvar,
     *        modtype,modk,modn,modv,dependent)
      endif
      
      


      RETURN 
      END 



C     LOCAL SEARCH WITH SIM SINGLE.
C     COMPUTES THE JACOBIAN MATRIX, J = J(X)
C     J(I,K) IS SET TO THE PARTIAL 
C     DERIVATIVE OF COMPONENT I OF R WITH RESPECT TO X(K).
C     
C     NOTE: LTY the variable to consider
C
C     N - number of data-points (IN)
C     P - number of parameters (IN)
C     X - parameters, length P (IN)
C     NF - invocation count, see below  (IN/OUT)
C     J - Jacobian (OUT)
C     LTY - additional integer inputs (IN)
C     LTY(1) - the variable to consider
C     TY - additional real input, here doesn't used (IN)
C     UF - additional function, here doesn't used (IN)
C
C     A SUBROUTINE WHICH, GIVEN X, COMPUTES THE JACOBIAN
C     MATRIX J OF R AT X, I.E., THE N BY P MATRIX WHOSE
C     (I,K) ENTRY IS THE PARTIAL DERIVATIVE OF THE I-TH
C     COMPONENT OF R WITH RESPECT TO X(K).  CALCJ MUST BE
C     DECLARED EXTERNAL IN THE CALLING PROGRAM.  IT IS
C     INVOKED BY
C     CALL CALCJ(N,P,X,NF,J,UIPARM,URPARM,UFPARM)
C     NF IS THE INVOCATION COUNT FOR CALCR AT THE TIME
C     R(X) WAS EVALUATED.  THE X PASSED TO CALCJ IS
C     USUALLY THE ONE PASSED TO CALCR ON EITHER ITS MOST
C     RECENT INVOCATION OR THE ONE PRIOR TO IT.  IF CALCR
C     SAVES INTERMEDIATE RESULTS FOR USE BY CALCJ, THEN IT
C     IS POSSIBLE TO TELL FROM NF WHETHER THEY ARE VALID
C     FOR THE CURRENT X (OR WHICH COPY IS VALID IF TWO
C     COPIES ARE KEPT).  IF J CANNOT BE COMPUTED AT X,
C     THEN CALCJ SHOULD SET NF TO 0.  IN THIS CASE, NL2SOL
C     WILL RETURN WITH IV(1) = 15.  THE OTHER PARAMETERS
C     TO CALCJ ARE AS DESCRIBED ABOVE AND BELOW.  
C
C     DO NOT CHANGE N, P, OR X.
C
      SUBROUTINE JACOB3(N, P, X, NF, J, LTY, TY, UF) 

      implicit none
      INTEGER N, P, NF, LTY(1)
      DOUBLE PRECISION X(P), J(N,P), TY(1) 
      EXTERNAL UF 
      INTEGER I 


      integer nvar,nexp
      integer maxexp,maxvar,maxpts,maxr,maxv,maxk
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)

      

C     ------ MODEL ------
      integer modtype(maxvar,maxr) 
C     Type of reaction [1...maxr] for variable [1...maxvar]
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=2: Lower bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=3: Upper bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      integer modn(maxvar) 
C     Number of reactions for variable [1...maxvar]
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      logical dependent(maxvar) 
C     Which variables are dependent

      integer nvare,npts(maxexp),npts2
      double precision edata(maxexp,maxvar+1,2*maxpts)
      double precision edata2(maxexp,maxvar+1,2*maxpts)
      integer spline(maxexp,maxvar) ! 0=linear interpolation, 1=cubic smoothing spline 
      logical useip(maxvar)

      
      double precision R(N),RORG(N),RES(N) ! residuals
      double precision error,DELTA
      

      integer ivar, debug, IEQ,ipara,ireact,getKsOfType,jj

      common/mydata/edata,spline,npts,nexp,nvar,nvare
      common/mydata2/edata2,npts2,useip
      common/mydata3/modk,modkinit,modn,modv,modtype,dependent

      
      ivar=LTY(1)
      debug=0



      if (debug.gt.0) then 
         write(*,*) 'JACOB3, N=',N,' P=',P,' X=',(X(i),i=1,P)
         write(*,*) 'JACOB3, LTY=',LTY(1)
         call printvar(maxvar,maxr,maxv,maxk,nvar,
     *        modtype,modk,modn,modv,dependent,ivar)
      endif
      

      
C     X to Model
      ipara=1
      if (dependent(ivar)) then
         do 810 ireact=1,modn(ivar)
            do 800 jj=1,getKsOfType(modtype(ivar,ireact))
               modk(ivar,ireact,jj,1)=X(ipara)
               ipara=ipara+1
 800        continue
 810     continue
      endif

 
      call errvar(error,RORG,RES,N,ivar)


      if (debug.gt.0) then 
         write(*,*) 'JACOB3, error=',error
      endif
      
      
      do 30 I=1,P
         DELTA=ABS(X(I))*1.d-6
C        This following is needed to avoid division by zero further down
C        when X(I) is close to zero
         DELTA=MAX(DELTA,1.d-14) 
         X(I)=X(I)+DELTA        ! DELTA CHANGE


         
C        X to Model
         ipara=1
         if (dependent(ivar)) then
            do 210 ireact=1,modn(ivar)
               do 200 jj=1,getKsOfType(modtype(ivar,ireact))
                  modk(ivar,ireact,jj,1)=X(ipara)
                  ipara=ipara+1
 200           continue
 210        continue
         endif
  
         call errvar(error,R,RES,N,ivar)

         if (debug.gt.1) then 
            write(*,*) 'JACOB3, I=',I,' error=',error,' P=',P,' N',N
            write(*,*) 'JACOB3, DELTA=',DELTA
         endif
         X(I)=X(I)-DELTA        !RESET

C        X to Model
         ipara=1
         if (dependent(ivar)) then
            do 310 ireact=1,modn(ivar)
               do 300 jj=1,getKsOfType(modtype(ivar,ireact))
                  modk(ivar,ireact,jj,1)=X(ipara)
                  ipara=ipara+1
 300           continue
 310        continue
         endif

         do 20 IEQ=1,N
            J(IEQ,I)=-(R(IEQ)-RORG(IEQ))/DELTA
c$$$            if (I.eq.7) write(*,*) (R(IEQ)-RORG(IEQ)),' ',DELTA,' '
c$$$     $           ,J(IEQ,I),' N=',N
 20      CONTINUE

 30   CONTINUE     
      
      
      if (debug.gt.0) then 
         write(*,*) 'eval JACOB3, error ',error
         if (debug.gt.0) then 
            write(*,*) 'R (1..11): ',(R(i),i=1,11)
            write(*,*) 'RES (1..11): ',(RES(i),i=1,11)
            write(*,*) 'J (1..11,1): ',(J(i,1),i=1,11)
            
            call printmodel(maxvar,maxr,maxv,maxk,nvar,
     *           modtype,modk,modn,modv,dependent)

         endif
      endif




      RETURN 
      END 




