C     This file was automatically generated by GenerateFortran.generate()
C     on Wed Feb 06 14:05:22 CET 2013
C
C    Odeidon, a program for structural identification of ODEs
C    Copyright (C) 2011 Peter Gennemark, Dag Wedelin
C
C    This program is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with this program.  If not, see <http://www.gnu.org/licenses/>.

C    Contact: Peter Gennemark, Dag Wedelin
C             www.odeidentification.org
C
C
C
C     Estimate parameters for some variables simulatanously using dn2gb
C     Which variables are specified in common block logical var(maxvar)
C     extreme cases are estvar (one variable) and est (all variables)
      subroutine estvars(edata,spline,
     *     nexp,nvare,npts,
     *     nvar,
     *     modtype,modk,modkinit,modn,modv,dependent,
     *     error)

      implicit none
      integer maxexp,maxvar,maxpts,maxv,maxk,maxr
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)
      integer nexp,nvare,npts(maxexp)
      double precision edata(maxexp,maxvar+1,2*maxpts)
      integer spline(maxexp,maxvar) ! 0=linear interpolation, 1=cubic smoothing spline 
           
      integer nvar
      
C     ------ MODEL ------
      integer modtype(maxvar,maxr) 
C     Type of reaction [1...maxr] for variable [1...maxvar]
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=2: Lower bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=3: Upper bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      integer modn(maxvar) 
C     Number of reactions for variable [1...maxvar]
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      logical dependent(maxvar) 
C     Which variables are dependent
      
      double precision error
      integer debug,ipara,ivar,i,iLIV,iLV,ireact,iexp
      integer getKsOfType

      INTEGER P, LIV, LV, UI(1),NF,N,LR
      DOUBLE PRECISION B(2,75), TY(1), X(75) 
      EXTERNAL DUMMY, JACOB4, FUN4
      parameter(LIV=382,LV=24942,LR=156) ! automatically set
      double precision R(LR),RES(LR),V(LV)
      INTEGER IV(LIV)

      logical var(maxvar)
      integer idummy
      logical initconc          ! T if init conc consider as parameter, ow F
      common/myinitconc/initconc
      common/simulg/var,idummy
      common/myBest2/B ! communicates estvars-fun4


!     LIV = 82 + 4*P
!     LV = 105 + P*(N + 2*P + 21) + 2*N
 
      debug=0
      P=0
      N=0
      do 10, ivar=1,nvar
         if (var(ivar).and.dependent(ivar)) then 
            do 8, ireact=1,modn(ivar)
               P=P+getKsOfType(modtype(ivar,ireact))
 8          continue
            do 9, iexp=1,nexp
               N=N+npts(iexp)
 9          continue
            if (initconc) P=P+nexp ! initial conc
         endif
 10   continue
      
      if (P.gt.75) then
         write(*,*) 'estvars, ivar=',ivar,' P ',P
     $        ,' > 75. Increase sizes of datastructures'
         stop
      endif

      if (debug.gt.1) write(*,*) 'estvars, P ',P,' N='
     $     ,N
      iLIV = 82 + 4*P
      iLV = 105 + P*(N + 2*P + 21) + 2*N
      if (iLIV.gt.LIV) then
         write(*,*) 'estvars, LIV should be ', iLIV, ' is ',LIV
         stop
      endif
      if (iLV.gt.LV) then
         write(*,*) 'estvars, LV should be ', iLV, ' is ',LV
         stop
      endif
      if (N.gt.LR) then
         write(*,*) 'estvars, LR should be ', N, ' is ',LR
         write(*,*) 'estvars, also check R and RES.'
         stop
      endif
      
      
      call varstox (nvar,
     *     modtype,modk,modkinit,modn,modv,dependent,nexp,X,B,P)
      
      if (debug.gt.0) then
         do 80 i=1,P
            write(*,*) 'estvars, X(',i,')=',X(i),' [',B(1,i),', ',B(2,i)
     $           ,']'
 80      continue   
      endif
      
      DO 90 I=1,LIV 
         IV(I)=0
 90   CONTINUE 
      DO 100 I=1,LV 
         V(I)=0.E0
 100  CONTINUE  

      call DN2GB(N,P,X, B, FUN4, JACOB4, IV, LIV, LV, V, UI, TY,DUMMY) 
     
      call xtovars (nvar,
     *     modtype,modk,modkinit,modn,modv,dependent,nexp,X,P) 
     
      call errvars(error,R,RES,N)


      if (debug.gt.0) then
         write(*,*) 'IV1= ',IV(1)
         call printmodel(maxvar,maxr,maxv,maxk,nvar,
     *        modtype,modk,modn,modv,dependent)
         write(*,*) 'Error=',error
      endif
      end

      
C     Estimate parameters for some variables simulatanously using dn2gb
C     Which variables are specified in common block logical var(maxvar)
C     extreme case estgeneral (all variables)
      subroutine estvarsgeneral(edata,spline,
     *     nexp,nvare,npts,
     *     nvar,
     *     modtype,modk,modkinit,modn,modv,dependent,
     *     error)

      implicit none
      integer maxexp,maxvar,maxpts,maxv,maxk,maxr
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)
      integer nexp,nvare,npts(maxexp)
      double precision edata(maxexp,maxvar+1,2*maxpts)
      integer spline(maxexp,maxvar) ! 0=linear interpolation, 1=cubic smoothing spline 
           
      integer nvar

      
C     ------ MODEL ------
      integer modtype(maxvar,maxr) 
C     Type of reaction [1...maxr] for variable [1...maxvar]
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=2: Lower bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=3: Upper bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      integer modn(maxvar) 
C     Number of reactions for variable [1...maxvar]
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      logical dependent(maxvar) 
C     Which variables are dependent

      
      double precision error
      integer debug,ipara,P2
      integer ivar,i,iLIV,iLV,ireact,iexp

      INTEGER P, LIV, LV, UI(1),NF,N,LR
      DOUBLE PRECISION B(2,75), TY(1), X(75) 
      EXTERNAL DUMMY, JACOB4GENERAL, FUN4GENERAL
      parameter(LIV=382,LV=24942,LR=156) ! automatically set
      double precision R(LR),RES(LR),V(LV)
      INTEGER IV(LIV)

      logical var(maxvar)
      integer idummy
      logical initconc          ! T if init conc consider as parameter, ow F
      common/myinitconc/initconc
      common/simulg/var,idummy  
      common/myBest2g/B ! communicates estvarsgeneral-fun4general

!     LIV = 82 + 4*P
!     LV = 105 + P*(N + 2*P + 21) + 2*N
 
      debug=0
C     get no of parameters P, X and B
      call varstoxgeneral(nvar,
     *     modtype,modk,modkinit,modn,modv,dependent,nexp,
     *     X,B,200,P,initconc)

      N=0
      do 10, ivar=1,nvar
         if (dependent(ivar).and.var(ivar)) then
            do 9, iexp=1,nexp
               N=N+npts(iexp)
 9          continue
         endif
 10   continue
      
      if (P.gt.75) then
         write(*,*) 'estvarsgeneral, ivar=',ivar,' P ',P,
     *        ' > 75. Increase sizes of datastruct, ',
     *        'check hardcoded values in code as well'
         stop
      endif
      
      if (debug.gt.1) write(*,*) 'estvarsgeneral, P ',P,' N='
     $     ,N
      iLIV = 82 + 4*P
      iLV = 105 + P*(N + 2*P + 21) + 2*N
      if (iLIV.gt.LIV) then
         write(*,*) 'estvarsgeneral, LIV should be ', iLIV, ' is ',LIV
         stop
      endif
      if (iLV.gt.LV) then
         write(*,*) 'estvarsgeneral, LV should be ', iLV, ' is ',LV
         stop
      endif
      if (N.gt.LR) then
         write(*,*) 'estvarsgeneral, LR should be ', N, ' is ',LR
         write(*,*) 'estvarsgeneral, also check R and RES.'
         stop
      endif
    

      call varstoxgeneral(nvar,
     *     modtype,modk,modkinit,modn,modv,dependent,nexp,
     *     X,B,P,P2,initconc)

      if (debug.gt.0) then
         do 80 i=1,P
            write(*,*) 'estvarsgeneral, X(',i,')=',X(i),' [',B(1,i),', '
     $           ,B(2,i),']'
 80      continue   
      endif

      DO 90 I=1,LIV 
         IV(I)=0
 90   CONTINUE 
      DO 100 I=1,LV 
         V(I)=0.E0
 100  CONTINUE 
      if (debug.gt.0) write(*,*) 'estvarsgeneral, call dn2gb'
      CALL DN2GB(N,P,X, B, FUN4GENERAL, JACOB4GENERAL, IV, LIV, LV, V,
     $     UI, TY,DUMMY) 


      if (debug.gt.0) then
         do 81 i=1,P
            write(*,*) 'estvarsgeneral, X(',i,')=',X(i),' [',B(1,i),', '
     $           ,B(2,i),']'
 81      continue   
      endif
      call xtovarsgeneral(nvar,
     *     modtype,modk,modkinit,modn,modv,dependent,nexp,
     *     X,P,initconc)
 
      call errvars(error,R,RES,N)

      if (debug.gt.0) then
         write(*,*) 'IV1= ',IV(1)
         call printmodel(maxvar,maxr,maxv,maxk,nvar,
     *        modtype,modk,modn,modv,dependent)
         write(*,*) 'Error=',error

         write(*,*) 'estvarsgeneral, error=',error
      endif
      end




