C     This file was automatically generated by GenerateFortran_myReactions.generate()
C     on Wed Feb 06 14:05:22 CET 2013
C

C     Get number of defined reaction types
      integer function getNumberOfReactionTypes()
      implicit none
      getNumberOfReactionTypes=2
      return
      end
      

C     Get name of reaction type itype
      character*30 function getNameOfReactionType(itype)
      implicit none
      integer itype
      if (itype.eq.1) then
         getNameOfReactionType='uniMolecularMassAction'
      else if (itype.eq.2) then
         getNameOfReactionType='biMolecularMassAction'
      else
         write(*,*) 'code_rk_myreactions.getNameOfReactionType',
     *     ', error itype=',itype
         stop
         getNameOfReactionType= 'Error in getNameOfReactionType'
      endif
      end
      

C     Get name of local variable iname of reaction type itype
      character*30 function getVariableNameOfReactionType(iname,itype)
      implicit none
      integer itype,iname
      if (itype.eq.1) then
         if (iname.eq.1) then
            getVariableNameOfReactionType='X1'
            return
         endif
      else if (itype.eq.2) then
         if (iname.eq.1) then
            getVariableNameOfReactionType='X1'
            return
         else if (iname.eq.2) then
            getVariableNameOfReactionType='X2'
            return
         endif
      endif
      write(*,*) 'code_rk_myreactions.getVariableNameOfReactionType',
     *  'error iname=',iname
      write(*,*) 'code_rk_myreactions.getVariableNameOfReactionType',
     *  'error itype=',itype
      stop
      getVariableNameOfReactionType='Error in getNameOfReactionType'
      end
      

C     Get name of local parameter ipara of reaction type itype
      character*30 function getParameterNameOfReactionType(ipara,itype)
      implicit none
      integer itype,ipara
      if (itype.eq.1) then
         if (ipara.eq.1) then
            getParameterNameOfReactionType='k1'
            return
         endif
      else if (itype.eq.2) then
         if (ipara.eq.1) then
            getParameterNameOfReactionType='k1'
            return
         endif
      endif
      write(*,*) 'code_rk_myreactions.getParameterNameOfReactionType',
     *  'error ipara=',ipara
      write(*,*) 'code_rk_myreactions.getParameterNameOfReactionType',
     *  'error itype=',itype
      stop
      getParameterNameOfReactionType='Error in getNameOfReactionType'
      end
      

C     Get equation of reaction type itype
      character*200 function getEquationOfReactionType(itype)
      implicit none
      integer itype
      if (itype.eq.1) then
         getEquationOfReactionType='k1*X1'
      else if (itype.eq.2) then
         getEquationOfReactionType='k1*X1*X2'
      else
        write(*,*) 'code_rk_myreactions.getEquationOfReactionType',
     *    'error itype=',itype
        stop
        getEquationOfReactionType='Error in getNameOfReactionType'
      endif
      end
      

C     Get itype of reaction with name
      integer function getIndexOfReactionType(name)
      implicit none
      character*30 name,getNameOfReactionType
      integer i,getNumberOfReactionTypes
      getIndexOfReactionType=-1
      do 100 i=1,getNumberOfReactionTypes()
         if (name.eq.getNameOfReactionType(i)) then
            getIndexOfReactionType=i
            return
         endif
 100  enddo
      write(*,*) 'code_rk_myreactions.getIndexOfReactionType(',
     *  name,'), error'
      stop
      end
      

C     Get number of parameters of type itype
      integer function getKsOfType(itype)
      implicit none
      integer itype
      if (itype.eq.1) then
         getKsOfType=1
      else if (itype.eq.2) then
         getKsOfType=1
      else
        write(*,*) 'code_rk_myreactions.getKsOfType',
     *    'error itype=',itype
        stop
        getKsOfType=-1
      endif
      end
      

C     Get number of variables of type itype
      integer function getVsOfType(itype)
      implicit none
      integer itype
      if (itype.eq.1) then
         getVsOfType=1
      else if (itype.eq.2) then
         getVsOfType=2
      else
        write(*,*) 'code_rk_myreactions.getVsOfType',
     *    'error itype=',itype
        stop
        getVsOfType=-1
      endif
      end
      

C     Set value for parameter ipara of a reaction of type itype.
C     itype - the type of the reaction
C     ipara - parameter number to consider, 1..getKsOfType(itype)
C     lowbound- lower bound
C     uppbound - upper bound
C     value - (output) the initial value
      subroutine getInitialValue(itype,ipara,
     *     lowbound,uppbound,value)
      implicit none
      integer itype,ipara
      integer ireact
      double precision lowbound,uppbound,value
      double precision closetozero
      closetozero=lowbound
      if (uppbound.le.0.d0) closetozero=uppbound
      if (itype.eq.1) then
         if (ipara.eq.1) then
            value=closetozero
            return
         endif
      else if (itype.eq.2) then
         if (ipara.eq.1) then
            value=closetozero
            return
         endif
      endif
      write(*,*) 'code_rk_myreactions.getInitialValue',
     *  'error ipara=',ipara
      write(*,*) 'code_rk_myreactions.getInitalValue',
     *  'error itype=',itype
      stop
      end
      

C     Print euqation for model variable ivar
      subroutine printvar(maxvar,maxr,maxv,maxk,nvar,
     *     modtype,modk,modn,modv,dependent,ivar)
      implicit none
      integer maxvar,maxr,maxv,maxk,nvar
C     ------------- BEGIN MODEL DEFINITION -------------------------
      integer modtype(maxvar,maxr)
C     Type of reaction [1...maxr] for variable [1...maxvar]
      
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=2: LB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=3: UB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
      
      integer modn(maxvar)
C     Number of reactions for variable [1...maxvar]
      
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      
      logical dependent(maxvar)
C     Which variables are dependent
C     ------------- END MODEL DEFINITION -------------------------
      integer ivar,j
      write(*,5) 'dX(',ivar,')/dt='
  5   format(A,I2,A)
      do 10 j=1,modn(ivar)
      if (modtype(ivar,j).eq.1) then
         write(*,100) modk(ivar,j,1,1),'*X(',modv(ivar,j,1),')'
 100     format(D11.4,A,I2,A)
      else if (modtype(ivar,j).eq.2) then
         write(*,101) modk(ivar,j,1,1),'*X(',modv(ivar,j,1),')*X(',mod
     *     v(ivar,j,2),')'
 101     format(D11.4,A,I2,A,I2,A)
      else
      write(*,*) 'code_rk_myreactions.printvar, ',
     *           'incorrect type, ivar=',ivar,
     *           'modtype(',ivar,
     *           ',',j,')',modtype(ivar,j) 
            stop
         endif
 10   enddo
      end
      

C     LOCAL SEARCH WITH DERIVATIVE METHOD
C     COMPUTES THE RESIDUAL VECTOR, R = R(X)
C 
C     NOTE: LTY the variable to consider
C
C     N - number of data-points (IN)
C     P - number of parameters (IN)
C     X - parameters, length P (IN)
C     NF - invocation count, see below  (IN/OUT)
C     R - residuals (OUT)
C     LTY - additional integer input, here the variable to consider (IN)
C     TY - additional real input, here doesn't used (IN)
C     UF - additional function, here doesn't used (IN)
C
C     WHEN CALCR IS CALLED, NF IS THE INVOCATION COUNT
C     FOR CALCR.  IT IS INCLUDED FOR POSSIBLE USE WITH
C     CALCJ.  IF X IS OUT OF BOUNDS (E.G. IF IT WOULD
C     CAUSE OVERFLOW IN COMPUTING R(X)), THEN CALCR SHOULD
C     SET NF TO 0.  THIS WILL CAUSE A SHORTER STEP TO BE
C     ATTEMPTED.   
C
C     DO NOT CHANGE N, P, OR X.
C
      subroutine FUN2(N, P, X, NF, R, LTY, TY, UF) 
      implicit none
      integer N, P, NF, LTY(1) 
      double precision X(P), R(N), TY(1) 
      external UF 
C
      integer nvar,nexp
      integer maxexp,maxvar,maxpts,maxr,maxv,maxk
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)
C     ------------- BEGIN MODEL DEFINITION -------------------------
      integer modtype(maxvar,maxr)
C     Type of reaction [1...maxr] for variable [1...maxvar]
      
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=2: LB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=3: UB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
      
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      
      integer modn(maxvar)
C     Number of reactions for variable [1...maxvar]
      
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      
      logical dependent(maxvar)
C     Which variables are dependent
C     ------------- END MODEL DEFINITION -------------------------
      integer nvare,npts(maxexp),npts2
      double precision edata(maxexp,maxvar+1,2*maxpts)
      double precision edata2(maxexp,maxvar+1,2*maxpts)
      integer spline(maxexp,maxvar) ! 0=lin. interpol., 1=cubic smoothing spline
      logical useip(maxvar) 
      integer ivar,ipara,j,ireact,iexp,k,i,ieq,jj 
      double precision gydot,RES,vtot  
      integer debug 
      double precision B(2,75),TINY 
      common/mydata/edata,spline,npts,nexp,nvar,nvare
      common/mydata2/edata2,npts2,useip
      common/mydata3/modk,modkinit,modn,modv,modtype,dependent
      common/myB/B ! communicates with estvar
      TINY=0.001d0
      TINY=1.d-10
      do 20 jj=1,P
         if (X(jj).ge.B(1,jj)-TINY.and.X(jj).le.B(2,jj)+TINY) then
         else
            do 10 ieq=1,N
               R(ieq)=1.d10
 10        enddo
            NF=0
            return
         endif
 20    enddo
      debug=0
      ivar=LTY(1)
      ieq=1
      do 400 iexp=1,nexp
         do 300 k=2,npts(iexp)
            ipara=1
            vtot=0.d0
            do 200 ireact=1,modn(ivar)
C     ---------------------------- uniMolecularMassAction
               if (modtype(ivar,ireact).eq.1) then
                  vtot=vtot+X(ipara+0)*edata(iexp,modv(ivar,ireact,1)+
     *              1,k)
                  ipara=ipara+1
C     ---------------------------- biMolecularMassAction
               else if (modtype(ivar,ireact).eq.2) then
                  vtot=vtot+X(ipara+0)*edata(iexp,modv(ivar,ireact,1)+
     *              1,k)*edata(iexp,modv(ivar,ireact,2)+1,k)
                  ipara=ipara+1
               else
                 write(*,*) 'code_rk_myreactions.FUN2, error: ',
     *                 'modtype(',ivar,',',ireact,')',
     *                 modtype(ivar,ireact)
                 stop
              endif
200        continue
            if (useip(ivar)) then 
               R(ieq) = vtot-edata(iexp,ivar,maxpts+k)
           else
               R(ieq) = vtot-gydot(nexp,nvare,npts2,
     *              edata2,
     *              iexp,ivar,edata(iexp,1,k))
            endif
            ieq=ieq+1
 300     enddo 
 400  enddo
      if (N.ne.(ieq-1)) then
         write(*,*) 'code_rk_myreactions.FUN2, incorrect N=',N
         stop
      endif
      END 

C     LOCAL SEARCH WITH DERIVATIVE METHOD
C     COMPUTES THE JACOBIAN MATRIX, J = J(X)
C     J(I,K) IS SET TO THE PARTIAL 
C     DERIVATIVE OF COMPONENT I OF R WITH RESPECT TO X(K).
C  
C     NOTE: LTY the variable to consider
C     N - number of data-points (IN)
C     P - number of parameters (IN)
C     X - parameters, length P (IN)
C     NF - invocation count, see below  (IN/OUT)
C     J - Jacobian (OUT)
C     LTY - additional integer input, here the variable to consider (IN)
C     TY - additional real input, here doesn't used (IN)
C     UF - additional function, here doesn't used (IN)
C     A subroutine WHICH, GIVEN X, COMPUTES THE JACOBIAN
C     MATRIX J OF R AT X, I.E., THE N BY P MATRIX WHOSE
C     (I,K) ENTRY IS THE PARTIAL DERIVATIVE OF THE I-TH
C     COMPONENT OF R WITH RESPECT TO X(K).  CALCJ MUST BE
C     DECLARED external IN THE CALLING PROGRAM.  IT IS
C     INVOKED BY
C     CALL CALCJ(N,P,X,NF,J,UIPARM,URPARM,UFPARM)
C     NF IS THE INVOCATION COUNT FOR CALCR AT THE TIME
C     R(X) WAS EVALUATED.  THE X PASSED TO CALCJ IS
C     USUALLY THE ONE PASSED TO CALCR ON EITHER ITS MOST
C     RECENT INVOCATION OR THE ONE PRIOR TO IT.  IF CALCR
C     SAVES INTERMEDIATE RESULTS FOR USE BY CALCJ, THEN IT
C     IS POSSIBLE TO TELL FROM NF WHETHER THEY ARE VALID
C     FOR THE CURRENT X (OR WHICH COPY IS VALID IF TWO
C     COPIES ARE KEPT).  IF J CANNOT BE COMPUTED AT X,
C     THEN CALCJ SHOULD SET NF TO 0.  IN THIS CASE, NL2SOL
C     WILL RETURN WITH IV(1) = 15.  THE OTHER PARAMETERS
C     TO CALCJ ARE AS DESCRIBED ABOVE AND BELOW.
C     DO NOT CHANGE N, P, OR X.
      subroutine JACOB2(N, P, X, NF, J, LTY, TY, UF) 
      implicit none
      integer N, P, NF, LTY(1) 
      double precision X(P), J(N,P), TY(1) 
      external UF
      integer nvar,nexp
      integer maxexp,maxvar,maxpts,maxr,maxv,maxk
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)
C     ------------- BEGIN MODEL DEFINITION -------------------------
      integer modtype(maxvar,maxr)
C     Type of reaction [1...maxr] for variable [1...maxvar]
      
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=2: LB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=3: UB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
      
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      
      integer modn(maxvar)
C     Number of reactions for variable [1...maxvar]
      
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      
      logical dependent(maxvar)
C     Which variables are dependent
C     ------------- END MODEL DEFINITION -------------------------
      double precision stdev(maxexp,maxvar,maxpts), lambda
      integer nvare,npts(maxexp)
      double precision edata(maxexp,maxvar+1,2*maxpts)
      integer spline(maxexp,maxvar) ! 0=linear interpolation, 1=cubic smoothing spline 
      integer ivar,ipara,jj,ireact,ieq,iexp,i,k
      double precision vtot,DELTA
      integer debug
      common/mydata/edata,spline,npts,nexp,nvar,nvare
      common/mydata3/modk,modkinit,modn,modv,modtype,dependent
      common/errsettings/stdev,lambda
      debug=0
      ivar=LTY(1)
      ieq=1
      do 400 iexp=1,nexp
         do 300 k=2,npts(iexp)
            ipara=1
            vtot=0.d0
             do 200 ireact=1,modn(ivar)
C     ---------------------------- uniMolecularMassAction
               if (modtype(ivar,ireact).eq.1) then
                  J(ieq,ipara+0)=edata(iexp,modv(ivar,ireact,1)+1,k)
                  ipara=ipara+1
C     ---------------------------- biMolecularMassAction
               else if (modtype(ivar,ireact).eq.2) then
                  J(ieq,ipara+0)=edata(iexp,modv(ivar,ireact,1)+1,k)*e
     *              data(iexp,modv(ivar,ireact,2)+1,k)
                  ipara=ipara+1
               else
                  write(*,*) 'jac2, error modtype(',ivar,',',ireact,')',
     *                 modtype(ivar,ireact)
                  stop
               endif
 200        continue
            ieq=ieq+1
 300     enddo 
 400  enddo 
      if (N.ne.(ieq-1).or.P.ne.(ipara-1)) then
         write(*,*) 'code_rk_myreactions.JAC2, incorrect N=',N
         stop
      endif
      RETURN 
      END 

C     Simulate model
C     nvar - no of variables
C     nexp - no experiments
C     nvare- no variables in experiments
C     npts - no points in experiment
C     edata - exp data
C     sdata - simulated data OUTPUT
C     iexp - exp to simulate
C     istate - state of simulation (<0 indicates error) OUTPUT
      subroutine simulate(nvar,
     *     modtype,modk,modkinit,modn,modv,dependent,
     *     nexp,nvare,npts,
     *     edata,sdata,spline,
     *     iexp,
     *     istate)
      implicit none
      integer nvar,nexp 
      integer maxexp,maxvar,maxpts,maxr,maxv,maxk
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)
C     ------------- BEGIN MODEL DEFINITION -------------------------
      integer modtype(maxvar,maxr)
C     Type of reaction [1...maxr] for variable [1...maxvar]
      
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=2: LB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=3: UB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
      
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      
      integer modn(maxvar)
C     Number of reactions for variable [1...maxvar]
      
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      
      logical dependent(maxvar)
C     Which variables are dependent
C     ------------- END MODEL DEFINITION -------------------------
      integer nvare,npts
C     ------------- BEGIN EXPERIMENT DEFINITION -----------------------
      double precision edata(maxexp,maxvar+1,2*maxpts) 
      integer spline(maxexp,maxvar) ! 0=linear interpolation, 1=cubic smoothing spline 
C     ------------- END EXPERIMENT DEFINITION -------------------------
      double precision sdata(maxexp,maxvar+1,2*maxpts)
      external model, jac
      integer iexp,iexp2,ireact,i,j,icycle
      integer  iopt, iout, istate, itask, itol, liw, lrw
      parameter (lrw=92) ! 22+9*maxvar+maxvar**2
      parameter (liw=25)        ! 20+maxvar
      integer  mf,neq,iwork(liw)
      double precision  atol, rtol, rwork(lrw),t,tout, y(nvar),y0(nvar)
      logical debug
      common/simul/iexp2        ! communicates with subroutine jac
      debug=.false.
      if (nvar.ne.nvare) then   ! check parameters nvar and nvare
         write(*,*) 'simulate, nvar=',nvar,' nvare=',nvare
         stop
      endif
      if (iexp.lt.1.or.iexp.gt.nexp) then ! check parameter iexp
         write(*,*) 'simulate, error exp=',iexp
         return
      endif
      iexp2=iexp                ! make copy
      do 30 i=1,nvar            ! initial values
         y(i)=modkinit(iexp,i,1)
         if (debug) write(*,*) 'simulate, y0(',i,')=',y(i)
 30   continue
      neq = nvar
      itol = 1
      rtol = 1.D-4
      atol = 1.D-10
      itask = 1
      iopt = 0
      mf = 21 ! 21 == Jacobian supplied
              ! 22 == Jacobian not supplied
C     iopt=1
C     iwork(5)=0
C     iwork(6)=0 
C     iwork(7)=0
C     iwork(8)=0
C     iwork(9)=0
C     iwork(10)=0
C     rwork(5)=0.0
C     rwork(6)=(edata(iexp,1,npts)-edata(iexp,1,1))/50 ! hmax
C     rwork(6)=0.0
C     rwork(7)=0.0
C     rwork(8)=0.0
C     rwork(9)=0.0
C     rwork(10)=0.0
      t = edata(iexp,1,1)
      istate = 1
      do 140 iout = 1,npts
         tout = edata(iexp,1,iout)
         call dlsode (model, neq, y, t, tout, itol, rtol, atol, itask,
     *        istate, iopt, rwork, lrw, iwork, liw, jac, mf) 
         sdata(iexp,1,iout)=t   ! save time data
         do 135 i=1,neq         ! save variable data
            if (dependent(i)) then
               sdata(iexp,(i+1),iout)=y(i)
            else
               sdata(iexp,(i+1),iout)=edata(iexp,i+1,iout) 
           endif
 135     continue  
         if (istate.lt. 0)  go to 180
 140  continue 
      if (debug) write(*,160)  iwork(11), iwork(12), iwork(13)
 160  format(/'# No. steps =',i4,',No. f-s =',i4,',No. J-s =',i4)
      return
 180  if (debug) write(*,190)  istate
 190  format('dlsode, error halt. ISTATE =',I3)
      end

C     ODE model, called from dlsode
      subroutine model(neq,t,y,ydot)
      implicit none
      integer neq
      double precision t,y(neq),ydot(neq)
      double precision gysmth 
      integer maxexp,maxvar,maxpts,maxr,maxv,maxk
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)
C     ------------- BEGIN MODEL DEFINITION -------------------------
      integer modtype(maxvar,maxr)
C     Type of reaction [1...maxr] for variable [1...maxvar]
      
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=2: LB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=3: UB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
      
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      
      integer modn(maxvar)
C     Number of reactions for variable [1...maxvar]
      
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      
      logical dependent(maxvar)
C     Which variables are dependent
C     ------------- END MODEL DEFINITION -------------------------
      integer iexp,i,ireact
      common/simul/iexp        ! communicates with subroutine model 
      common/mydata3/modk,modkinit,modn,modv,modtype,dependent
      do 5 i=1,neq
         if (.not.dependent(i)) then
            y(i)=gysmth(iexp,i,t,0,
     *           .false.,       ! do not recalculate parameters
     *           0.d0)          ! dummies
            ydot(i)=0
         endif
 5    enddo
      do 100 i=1,neq
         if (dependent(i)) then
            ydot(i)=0
            do 10 ireact=1,modn(i)
C     ---------------------------- uniMolecularMassAction
               if (modtype(i,ireact).eq.1) then
                  ydot(i)=ydot(i)+modk(i,ireact,1,1)*y(modv(i,ireact,1
     *              ))
C     ---------------------------- biMolecularMassAction
               else if (modtype(i,ireact).eq.2) then
                  ydot(i)=ydot(i)+modk(i,ireact,1,1)*y(modv(i,ireact,1
     *              ))*y(modv(i,ireact,2))
               else
                  write(*,*) 'code_rk_myreactions.model, ',
     *                 'error modtype(',i,',',ireact,')',
     *                 modtype(i,ireact)
                  stop
               endif
 10         continue
         endif
 100  continue 
      end

C     Jacobian of ODE model, called from dlsode
      subroutine jac (neq, t, y, ml, mu, pd, nrowpd)
      implicit none
      integer neq, ml, mu, nrowpd
      double precision t, y, pd
      dimension y(neq), pd(nrowpd,neq)
      double precision gysmth
      integer maxexp,maxvar,maxpts,maxr,maxv,maxk
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)
C     ------------- BEGIN MODEL DEFINITION -------------------------
      integer modtype(maxvar,maxr)
C     Type of reaction [1...maxr] for variable [1...maxvar]
      
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=2: LB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=3: UB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
      
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      
      integer modn(maxvar)
C     Number of reactions for variable [1...maxvar]
      
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      
      logical dependent(maxvar)
C     Which variables are dependent
C     ------------- END MODEL DEFINITION -------------------------
      integer iexp,i,j,ireact
      common/mydata3/modk,modkinit,modn,modv,modtype,dependent
      common/simul/iexp
      do 5 i=1,neq
         if (.not.dependent(i)) then
            y(i)=gysmth(iexp,i,t,0,
     *           .false.,       ! do not recalculate parameters
     *           0.d0)          ! dummies
         endif
 5    enddo
      do 100 i=1,neq
         do 6 j=1,neq
            pd(i,j)=0.d0
 6       enddo
         if (dependent(i)) then
            do 10 ireact=1,modn(i)
C     ---------------------------- uniMolecularMassAction
               if (modtype(i,ireact).eq.1) then
                  pd(i,modv(i,ireact,1))=pd(i,modv(i,ireact,1))+modk(i
     *              ,ireact,1,1)
C     ---------------------------- biMolecularMassAction
               else if (modtype(i,ireact).eq.2) then
                  pd(i,modv(i,ireact,1))=pd(i,modv(i,ireact,1))+modk(i
     *              ,ireact,1,1)*y(modv(i,ireact,2))
               else
                  write(*,*) 'code_rk_myreactions.jac, ',
     *                 'error modtype(',i,',',ireact,')',
     *                 modtype(i,ireact)
                  stop
               endif
 10         continue
         endif
 100  continue 
      end

C     ODE model, called from dlsode
      subroutine modelsingle(neq,t,y,ydot)
      implicit none
      integer neq
      double precision t,y(neq),ydot(neq)
      double precision gysmth
      integer maxexp,maxvar,maxpts,maxr,maxv,maxk
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)
C     ------------- BEGIN MODEL DEFINITION -------------------------
      integer modtype(maxvar,maxr)
C     Type of reaction [1...maxr] for variable [1...maxvar]
      
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=2: LB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=3: UB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
      
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      
      integer modn(maxvar)
C     Number of reactions for variable [1...maxvar]
      
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      
      logical dependent(maxvar)
C     Which variables are dependent
C     ------------- END MODEL DEFINITION -------------------------
      integer i,npts2,nexp,nvar,npts(maxexp),nvare
      double precision edata(maxexp,maxvar+1,2*maxpts)
      double precision edata2(maxexp,maxvar+1,2*maxpts)
      integer spline(maxexp,maxvar) ! 0=linear interpolation, 1=cubic smoothing spline 
      integer iexp,ireact
      double precision ytemp(maxvar),gy
      logical debug,useip(maxvar)
      common/mydata/edata,spline,npts,nexp,nvar,nvare
      common/mydata2/edata2,npts2,useip
      common/mydata3/modk,modkinit,modn,modv,modtype,dependent
      common/simuls/i,iexp        ! communicates with subroutine model 
      if (.not.dependent(i)) then
         y(1)=gysmth(iexp,i,t,0,
     *        .false.,          ! do not recalculate parameters
     *        0.d0)        ! dummies
        ydot(1)=0
        return
      endif
      ydot(1)=0
      do 10 ireact=1,modn(i)
C     ---------------------------- uniMolecularMassAction
         if (modtype(i,ireact).eq.1) then
            if (i.eq.modv(i,ireact,1)) then ! i matches var 1
               ydot(1)=ydot(1)+modk(i,ireact,1,1)*y(1)
            else ! i does not matches any var
               if (useip(modv(i,ireact,1))) then
                  ytemp(1)=gysmth(iexp,modv(i,ireact,1),t,0,.false.,0.
     *              d0)
               else
                  ytemp(1)=gy(nexp,nvare,npts2,edata2,iexp,modv(i,irea
     *              ct,1),t)
               endif
               ydot(1)=ydot(1)+modk(i,ireact,1,1)*ytemp(1)
         endif
C     ---------------------------- biMolecularMassAction
         else if (modtype(i,ireact).eq.2) then
            if (i.eq.modv(i,ireact,1)) then ! i matches var 1
               if (useip(modv(i,ireact,2))) then
                  ytemp(2)=gysmth(iexp,modv(i,ireact,2),t,0,.false.,0.
     *              d0)
               else
                  ytemp(2)=gy(nexp,nvare,npts2,edata2,iexp,modv(i,irea
     *              ct,2),t)
               endif
               ydot(1)=ydot(1)+modk(i,ireact,1,1)*y(1)*ytemp(2)
            else if (i.eq.modv(i,ireact,2)) then ! i matches var 2
               if (useip(modv(i,ireact,1))) then
                  ytemp(1)=gysmth(iexp,modv(i,ireact,1),t,0,.false.,0.
     *              d0)
               else
                  ytemp(1)=gy(nexp,nvare,npts2,edata2,iexp,modv(i,irea
     *              ct,1),t)
               endif
               ydot(1)=ydot(1)+modk(i,ireact,1,1)*ytemp(1)*y(1)
            else ! i does not matches any var
               if (useip(modv(i,ireact,1))) then
                  ytemp(1)=gysmth(iexp,modv(i,ireact,1),t,0,.false.,0.
     *              d0)
               else
                  ytemp(1)=gy(nexp,nvare,npts2,edata2,iexp,modv(i,irea
     *              ct,1),t)
               endif
               if (useip(modv(i,ireact,2))) then
                  ytemp(2)=gysmth(iexp,modv(i,ireact,2),t,0,.false.,0.
     *              d0)
               else
                  ytemp(2)=gy(nexp,nvare,npts2,edata2,iexp,modv(i,irea
     *              ct,2),t)
               endif
               ydot(1)=ydot(1)+modk(i,ireact,1,1)*ytemp(1)*ytemp(2)
         endif
         else
            write(*,*) 'code_rk_sim, error modtype(',i,
     *           ',',ireact,')=',
     *           modtype(i,ireact)
            stop
         endif
 10   continue
      end 
C     Simulate submodel specied by bool var(maxvar)
C     Simulate and simulatesingle are special cases.
C     Experiment no to simulate set in common variable simulg
C     nvar - no of variables
C     nexp - no experiments
C     nvare- no variables in experiments
C     npts - no points in experiment
C     edata - exp data
C     sdata - simulated data OUTPUT
C     istate - state of simulation (<0 indicates error) OUTPUT
C     var - submodel, set in common block
C     iexp - exp to simulate, set in common block
      subroutine simulatevars(nvar,
     *     modtype,modk,modkinit,modn,modv,dependent,
     *     nexp,nvare,npts,
     *     edata,sdata,
     *     istate)
      implicit none
      integer nvar,nexp,ivar,ivar2
      integer maxexp,maxvar,maxpts,maxr,maxv,maxk
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)
C     ------------- BEGIN MODEL DEFINITION -------------------------
      integer modtype(maxvar,maxr)
C     Type of reaction [1...maxr] for variable [1...maxvar]
      
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=2: LB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=3: UB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
      
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      
      integer modn(maxvar)
C     Number of reactions for variable [1...maxvar]
      
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      
      logical dependent(maxvar)
C     Which variables are dependent
C     ------------- END MODEL DEFINITION -------------------------
C     ------------- BEGIN EXPERIMENT DEFINITION -----------------------
      double precision edata(maxexp,maxvar+1,2*maxpts) 
C     ------------- END EXPERIMENT DEFINITION -------------------------
      integer nvare,npts(maxexp),npts2
      double precision sdata(maxexp,maxvar+1,2*maxpts)
      external modelgeneral, jac
      integer iexp,i,j,k,ireact
      integer iopt, iout, istate, itask, itol, liw, lrw
      parameter (lrw=92) ! 22+9*maxvar+maxvar**2
      parameter (liw=25)        ! 20+maxvar
      integer mf,neq,iwork(liw)
      double precision  atol, rtol, rwork(lrw),t,tout
      double precision  y(maxvar),y0(maxvar)
      logical debug,var(maxvar) 
      common/simulg/var,iexp
      debug=.false.
      if (nvar.ne.nvare) then   ! check parameters nvar and nvare
         write(*,*) 'simulate, nvar=',nvar,' nvare=',nvare
         stop
      endif
      if (iexp.lt.1.or.iexp.gt.nexp) then ! check parameter iexp
         write(*,*) 'simulate, error exp=',iexp
         return
      endif
      do 30 i=1,nvar            ! initial values
         y(i)=modkinit(iexp,i,1)
 30   continue
      neq = nvar
      itol = 1
      rtol = 1.D-4
      atol = 1.D-10
      itask = 1
      iopt = 0
      mf = 22 ! 21 == Jacobian supplied
              ! 22 == Jacobian not supplied
C     iopt=1
C     iwork(5)=0
C     iwork(6)=0 
C     iwork(7)=0
C     iwork(8)=0
C     iwork(9)=0
C     iwork(10)=0
C     rwork(5)=0.0
C     rwork(6)=1.0 ! hmax
C     rwork(6)=0.0
C     rwork(7)=0.0
C     rwork(8)=0.0
C     rwork(9)=0.0
C     rwork(10)=0.0
      t = edata(iexp,1,1)
      istate = 1
      do 140 iout = 1,npts(iexp)
         tout = edata(iexp,1,iout)
         call dlsode (modelgeneral, neq, y, t, tout, itol, rtol, atol,
     *         itask,istate, iopt, rwork, lrw, iwork, liw, jac, mf) 
         sdata(iexp,1,iout)=t   ! save time data
         do 135 i=1,neq         ! save variable data
            if (dependent(i).and.var(i)) then
               sdata(iexp,(i+1),iout)=y(i)
            else
               sdata(iexp,(i+1),iout)=edata(iexp,i+1,iout) 
           endif
 135     continue  
         if (istate.lt. 0)  go to 180
 140  continue 
      if (debug) write(*,160)  iwork(11), iwork(12), iwork(13)
 160  format(/'# No. steps =',i4,',No. f-s =',i4,',No. J-s =',i4)
      return
 180  if (debug) write(*,190)  istate
 190  format('dlsode, error halt. ISTATE =',I3)
      end

C     ODE model, called from dlsode
C     simualte any number of variables (defined in bool var(maxvar))
C     Take others from data
      subroutine modelgeneral(neq,t,y,ydot)
      implicit none
      integer neq
      double precision t,y(neq),ydot(neq)
      double precision gysmth,gy
      integer maxexp,maxvar,maxpts,maxr,maxv,maxk
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)
C     ------------- BEGIN MODEL DEFINITION -------------------------
      integer modtype(maxvar,maxr)
C     Type of reaction [1...maxr] for variable [1...maxvar]
      
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=2: LB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=3: UB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
      
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      
      integer modn(maxvar)
C     Number of reactions for variable [1...maxvar]
      
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      
      logical dependent(maxvar)
C     Which variables are dependent
C     ------------- END MODEL DEFINITION -------------------------
	     integer i,ivar,npts2,nexp,nvar,npts(maxexp),nvare
      double precision edata(maxexp,maxvar+1,2*maxpts)
      double precision edata2(maxexp,maxvar+1,2*maxpts)
      integer spline(maxexp,maxvar) ! 0=lin. interpol.,1=cubic smooth. spline
      integer iexp,ireact
      double precision ytemp,ytemp2,ytemp3
      logical debug,useip(maxvar),var(maxvar)
      common/mydata/edata,spline,npts,nexp,nvar,nvare
      common/mydata2/edata2,npts2,useip
      common/mydata3/modk,modkinit,modn,modv,modtype,dependent
      common/simulg/var,iexp  ! communicates simulategeneral
      do 5 i=1,neq
         if (.not.dependent(i)) then ! Find values for dependent variables
           y(i)=gysmth(iexp,i,t,0,
     *           .false.,       ! do not recalculate parameters
     *           0.d0)     ! dummies
            ydot(i)=0
         endif
         if (.not.var(i)) then  ! Find values for variables that are not simulated
           if (useip(i)) then 
              y(i)=gysmth(iexp,i,t,0,
     *              .false.,    ! do not recalculate parameters
     *              0.d0)
            else
              y(i)=gy(nexp,nvare,npts2,
     *              edata2,
     *              iexp,i,t)
           endif
           ydot(i)=0
         endif
 5    enddo
      do 100 i=1,neq
         if (dependent(i).and.var(i)) then
            ydot(i)=0
            do 10 ireact=1,modn(i)
C     ---------------------------- uniMolecularMassAction
               if (modtype(i,ireact).eq.1) then
                  ydot(i)=ydot(i)+modk(i,ireact,1,1)*y(modv(i,ireact,1
     *              ))
C     ---------------------------- biMolecularMassAction
               else if (modtype(i,ireact).eq.2) then
                  ydot(i)=ydot(i)+modk(i,ireact,1,1)*y(modv(i,ireact,1
     *              ))*y(modv(i,ireact,2))
               else
                  write(*,*) 'code_rk_myreactions.modelgeneral, ',
     *                 'error modtype(',i,',',ireact,')',
     *                 modtype(i,ireact)
                  stop
               endif
 10         continue
         endif
 100  continue 
      end

C     Tune model with current global error
C     New estimation for each tried structure
C     Output new error
C     Model updated
      subroutine tunewithest(error,debug)
      implicit none
      integer maxexp,maxvar,maxpts,maxr,maxv,maxk
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)
C     ------------- BEGIN MODEL DEFINITION -------------------------
      integer modtype(maxvar,maxr)
C     Type of reaction [1...maxr] for variable [1...maxvar]
      
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=2: LB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=3: UB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
      
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      
      integer modn(maxvar)
C     Number of reactions for variable [1...maxvar]
      
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      
      logical dependent(maxvar)
C     Which variables are dependent
C     ------------- END MODEL DEFINITION -------------------------
C     ------------- BEGIN EXPERIMENT DEFINITION -----------------------
      double precision edata(maxexp,maxvar+1,2*maxpts) 
      integer spline(maxexp,maxvar) ! 0=linear interpolation, 1=cubic smoothing spline 
C     ------------- END EXPERIMENT DEFINITION -------------------------
      integer nexp,nvare,npts(maxexp)
      double precision error
      logical add
C     ------------- BEGIN TEMP MODEL DEFINITION -------------------------
      integer tmodtype(maxvar,maxr)
      double precision tmodk(maxvar,maxr,maxk,3) 
      double precision tmodkinit(maxexp,maxvar,3) 
      integer tmodn(maxvar)
      integer tmodv(maxvar,maxr,maxv)
C     ------------- END TEMP MODEL DEFINITION -------------------------
      integer nvar,ivar
      integer debug
      logical initconc          ! T if init conc consider as parameter, ow F
      integer isucc,nnn,i,ir,j
      double precision errtem
      logical didtune
      common/mydata/edata,spline,npts,nexp,nvar,nvare
      common/mydata3/modk,modkinit,modn,modv,modtype,dependent
      common/myinitconc/initconc
      call icopy(maxvar*maxr,modtype,1,tmodtype,1) ! make temp copy
      call dcopy(maxvar*maxr*maxk*3,modk,1,tmodk,1)
      call dcopy(maxvar*maxexp*3,modkinit,1,tmodkinit,1)
      call icopy(maxvar,modn,1,tmodn,1)
      call icopy(maxvar*maxr*maxv,modv,1,tmodv,1)
100   continue                  ! OUTER LOOP STARTS
      didtune=.false.
      do 1000 ivar=1,nvar
         nnn=modn(ivar)         ! reactions to remove
         do 500 ir=nnn,1,-1     ! remove one of the existing reactions
            do 400 j=1,2        ! 1: normal case, 2: for GMA
              if (j.eq.1) then ! This is the normal case
                 call rm(maxvar,maxr,maxv,maxk,nvar,
     *                 modtype,modk,modn,modv,dependent,
     *                 ivar,
     *                 ir,
     *                 isucc)
                 if (isucc.eq.0) then
                    write(*,*) 'tunewithest, error. rm-isucc=',isucc
                    stop
                 endif
              endif
              call estgeneral(errtem,.false.)
              if (debug.gt.0) then 
                 write(*,5000) 'tunewithest, ivar=',ivar,' ir=',ir
     $                 ,' error=',errtem
5000             format(A,I3,A,I3,A,D10.3)
                  if (debug.gt.1) call printvar(maxvar,maxr,maxv
     $                 ,maxk,nvar,modtype,modk,modn,modv,dependent
     $                 ,ivar)
              endif
              if (errtem.lt.error) then
                 error=errtem
                 call icopy(maxvar*maxr,modtype,1,tmodtype,1) ! make temp copy
                  call dcopy(maxvar*maxr*maxk*3,modk,1,tmodk,1)
                  call dcopy(maxvar*maxexp*3,modkinit,1,tmodkinit,1)
                  call icopy(maxvar,modn,1,tmodn,1)
                  call icopy(maxvar*maxr*maxv,modv,1,tmodv,1)
                  didtune=.true.
               else
                  call icopy(maxvar*maxr,tmodtype,1,modtype,1) ! Reset
                  call dcopy(maxvar*maxr*maxk*3,tmodk,1,modk,1)
                  call dcopy(maxvar*maxexp*3,tmodkinit,1,modkinit,1)
                  call icopy(maxvar,tmodn,1,modn,1)
                  call icopy(maxvar*maxr*maxv,tmodv,1,modv,1)
              endif
390           continue ! go here if rmv fails
400        continue  
500     continue               ! end remove one of existing reactions
1000  enddo
      if (didtune) goto 100
      end

C     Evalute subsystems of the current ODE for variable ivar
C
C     double precision errcur(maxvar), IN
C             Best error of the variables at start of main loop in main algorithm
C
C     double precision errloc  IN
C             best error so far when testing all testreactions
C             of this iteration of the main loop, can be smaller than errcur(ivar)
C              add=F, make sure that errloc is the best error so far, i.e., errcur(ivar)
C
C     double precision errbes  OUT
C             best error obtained in this subroutine
C
C     logical add, IN
C             add=T, a reaction was term was added, should not be removed.
C             add=F, no addition, consider all cases.
C
C     integer addterm, IN
C             addterm>0, a variable was added at the end of GMA term addterm, should not be removed.
C             addterm=0, no variable addition, consider all cases.
C
C     integer DEPTH, IN
C             1 or 2 reactions that can be removed 
C
C     integer debug, IN
C             0=none, 1=little, 2=much
C
C     terms refer to ODE term number
C     varindex =0 if traditional reaction
C     varindex > 0 if gma reaction
C     e.g a GMA reaction with 3 variables will contribute 3 rows to the (terms,varindex) table
C     terms  varindex
C      1        0       e.g  MM reaction
C      2        1       e.g. GMA 3 vars reaction
C      2        2       e.g. GMA 3 vars reaction
C      2        3       e.g. GMA 3 vars reaction
C      3        0       e.g  MM reaction
C      4        1       e.g. GMA 2 vars reaction
C      4        2       e.g. GMA 2 vars reaction
C
C      Table size is stored in tablesize
C
C
      subroutine estvarrm(ivar,errloc,errcur,errbes,add,
     *                    addterm,DEPTH,debug)
      implicit none
      integer maxexp,maxvar,maxpts,maxr,maxv,maxk
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)
C     ------------- BEGIN EXPERIMENT DEFINITION -----------------------
      double precision edata(maxexp,maxvar+1,2*maxpts) 
      integer spline(maxexp,maxvar) ! 0=linear interpolation, 1=cubic smoothing spline 
C     ------------- END EXPERIMENT DEFINITION -------------------------
      integer nexp,nvare,npts(maxexp)
      double precision errcur(maxvar)
      double precision errloc
      double precision errbes
      integer ivar,DEPTH,debug,addterm
      logical add
C     ------------- BEGIN MODEL DEFINITION -------------------------
      integer modtype(maxvar,maxr)
C     Type of reaction [1...maxr] for variable [1...maxvar]
      
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=2: LB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=3: UB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
      
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      
      integer modn(maxvar)
C     Number of reactions for variable [1...maxvar]
      
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      
      logical dependent(maxvar)
C     Which variables are dependent
C     ------------- END MODEL DEFINITION -------------------------
C     ------------- BEGIN TEMP MODEL DEFINITION -------------------------
      integer tmodtype(maxvar,maxr)
      double precision tmodk(maxvar,maxr,maxk,3) 
      double precision tmodkinit(maxexp,maxvar,3) 
      integer tmodn(maxvar)
      integer tmodv(maxvar,maxr,maxv)
C     ------------- END TEMP MODEL DEFINITION -------------------------
C     Temp model 2 corresponds to the best model
C     ------------- BEGIN TEMP MODEL DEFINITION 2-------------------------
      integer t2modtype(maxvar,maxr)
      double precision t2modk(maxvar,maxr,maxk,3) 
      double precision t2modkinit(maxexp,maxvar,3) 
      integer t2modn(maxvar)
      integer t2modv(maxvar,maxr,maxv)
C     ------------- END TEMP MODEL DEFINITION 2-------------------------
      integer nvar
      integer getKsOfType,getVsOfType
      logical promising
      logical initconc  ! T if init conc considered as parameter, ow F
      double precision stdev(maxexp,maxvar,maxpts), lambda
      integer isucc,nnn,i,ir1,ir2,jj,iv1,iv2,addedvar
      double precision errtem
      logical sign1,sign2
      integer ipara,ireact,j
      integer terms(100)  
      integer varindex(100) 
      integer tablesize

      common/mydata/edata,spline,npts,nexp,nvar,nvare
      common/mydata3/modk,modkinit,modn,modv,modtype,dependent
      common/errsettings/stdev,lambda
      common/myinitconc/initconc

      if (DEPTH.lt.1.or.DEPTH.gt.2) then
         write(*,*)'code_rk_myreactions, estvarrm, illegal DEPTH=',DEPTH
         stop
      endif
      errbes=errloc
      call icopy(maxvar*maxr,modtype,1,tmodtype,1) ! make temp copy
      call dcopy(maxvar*maxr*maxk*3,modk,1,tmodk,1)
      call icopy(maxvar,modn,1,tmodn,1)
      call icopy(maxvar*maxr*maxv,modv,1,tmodv,1)
      promising=.true.

      tablesize=0
      do 1500 ir1=1,modn(ivar)
         if (.true.) then
            if (ir1.eq.modn(ivar).and.add) then
               ! Skip this reaction
            else
               tablesize=tablesize+1
               terms(tablesize)=ir1 ! Traditional reaction type
               varindex(tablesize)=0
            endif
         endif
 1500 enddo
      ! Initial estimation
      if (add.or.addterm.gt.0) then 
         call estvar12(ivar,errtem)
      else
         call estvar(ivar,errtem,2,.true.)
      endif
      if (add.and.debug.gt.0) then
         if (errtem.lt.errcur(ivar).and.errtem.lt.errbes) then
            write(*,700) 'add ', modtype(ivar,modn(ivar)),' ',modv(iva
     *        r,modn(ivar),1),modv(ivar,modn(ivar),2),' (ir1/2=',0,0,') 
     *        err=',errtem,' < ',errcur(ivar),' *'
         else if (errtem.lt.errcur(ivar)) then
            write(*,701) 'add ', modtype(ivar,modn(ivar)),' ',modv(iva
     *        r,modn(ivar),1),modv(ivar,modn(ivar),2),' (ir1/2=',0,0,') 
     *         err=',errtem,' < ',errcur(ivar)
         else
            write(*,702) 'add ', modtype(ivar,modn(ivar)),' ',modv(iva
     *        r,modn(ivar),1),modv(ivar,modn(ivar),2),' (ir1/2=',0,0,') 
     *         err=',errtem
         endif
      endif
      if (addterm.gt.0.and.debug.gt.0) then
         addedvar=modv(ivar,addterm,getVsOfType(modtype(ivar,addterm))
     *     )
         if (errtem.lt.errcur(ivar).and.errtem.lt.errbes) then
            write(*,750) 'add var ',addedvar,' to term ',addterm,' err
     *        =',errtem,' < ',errcur(ivar),' *'
 750        format(A,I3,A,I3,A,D10.3,A,D10.3,A)
         else if (errtem.lt.errcur(ivar)) then
            write(*,751) 'add var ',addedvar,' to term ',addterm,' err
     *        =',errtem,' < ',errcur(ivar)
 751        format(A,I3,A,I3,A,D10.3,A,D10.3)
         else
            write(*,752) 'add var ',addedvar,' to term ',addterm,' err
     *        =',errtem
 752        format(A,I3,A,I3,A,D10.3)
         endif
      else if (.not.add.and.debug.gt.0) then
      endif
      if (.not.add.and.addterm.eq.0.and.debug.gt.0) then
         write(*,703) 'estvarrm, ir1/2=',0,',',0,' e=',errtem
      endif
      if (debug.gt.2) then 
         write(*,*) 'estvarrm, init error=',errtem
         call printvar(maxvar,maxr,maxv,maxk,nvar,modtype,modk,modn,mo
     *     dv,dependent,ivar)
      endif
      if (errtem.lt.errcur(ivar).and.errtem.lt.errbes) then
         errbes=errtem 
         ! Make a temporary copy
         call icopy(maxvar*maxr,modtype,1,t2modtype,1)
         call dcopy(maxvar*maxr*maxk*3,modk,1,t2modk,1)
         call icopy(maxvar,modn,1,t2modn,1)
         call icopy(maxvar*maxr*maxv,modv,1,t2modv,1)
      endif
      if (add) then
         if (errtem.gt.(errloc+lambda*getKsOfType(modtype(ivar,modn(iv
     *     ar))))) then
            promising=.false.
         endif
      endif
      if (addterm.gt.0) then
         if (errtem.gt.(errloc+lambda*1)) then ! one more parameter
            promising=.false.
         endif
      endif
      ! Remove existing terms
      ! Note that ir2>=ir1
      do 600 ir1=tablesize,1,-1
         do 500 ir2=tablesize,ir1,-1
            if (.not.promising) goto 300
            sign1=(modk(ivar,modn(ivar),1,2).ge.0.and.modk(ivar,terms(
     *        ir1),1,2).ge.0).or.(modk(ivar,modn(ivar),1,3).le.0.and.mod
     *        k(ivar,terms(ir1),1,3).le.0)
            !added react same sign as react to remove?
            sign2=(modk(ivar,modn(ivar),1,2).ge.0.and.modk(ivar,terms(
     *        ir2),1,2).ge.0).or.(modk(ivar,modn(ivar),1,3).le.0.and.mod
     *        k(ivar,terms(ir2),1,3).le.0)
            if (add.and.DEPTH.eq.1.and..not.sign1) goto 300
            if (add.and.DEPTH.eq.2.and.(.not.sign1.and..not.sign2)) go
     *        to 300
            if (ir1.eq.ir2) then ! Remove one term
               if (varindex(ir1).gt.0) then
                  call rmv(maxvar,maxr,maxv,maxk,nvar,modtype,modk,mod
     *              n,modv,dependent,ivar,varindex(ir1),terms(ir1),isucc
     *              )
               else
                  call rm(maxvar,maxr,maxv,maxk,nvar,modtype,modk,modn
     *              ,modv,dependent,ivar,terms(ir1),isucc)
               endif
               if (isucc.eq.0) goto 300
            else if (ir1.ne.ir2.and.DEPTH.eq.2) then ! Remove 2 terms
               if (varindex(ir2).gt.0) then
                  call rmv(maxvar,maxr,maxv,maxk,nvar,modtype,modk,mod
     *              n,modv,dependent,ivar,varindex(ir2),terms(ir2),isucc
     *              )
               else
                  call rm(maxvar,maxr,maxv,maxk,nvar,modtype,modk,modn
     *              ,modv,dependent,ivar,terms(ir2),isucc)
               endif
               if (isucc.eq.0) goto 300
               if (varindex(ir1).gt.0) then
                  call rmv(maxvar,maxr,maxv,maxk,nvar,modtype,modk,mod
     *              n,modv,dependent,ivar,varindex(ir1),terms(ir1),isucc
     *              )
               else
                  call rm(maxvar,maxr,maxv,maxk,nvar,modtype,modk,modn
     *              ,modv,dependent,ivar,terms(ir1),isucc)
               endif
               if (isucc.eq.0) goto 300
            else if (ir1.ne.ir2.and.DEPTH.eq.1) then ! Continue
               goto 300
            endif
            ! Estimation
            if (add.or.addterm.gt.0) then 
               call estvar12(ivar,errtem)
               else
               call estvar(ivar,errtem,2,.true.)
            endif
            if (debug.gt.2) then 
               write(*,*) 'estvarrm, init error=',errtem
               call printvar(maxvar,maxr,maxv,maxk,nvar,modtype,modk,m
     *           odn,modv,dependent,ivar)
            endif
            if (add.and.debug.gt.0) then
               if (errtem.lt.errcur(ivar).and.errtem.lt.errbes) then
                  write(*,700) 'add ', modtype(ivar,modn(ivar)),' ',mo
     *              dv(ivar,modn(ivar),1),modv(ivar,modn(ivar),2),' (ir1
     *              /2=',ir1,ir2,') err=',errtem,' < ',errcur(ivar),' *'
 700              format(A,I3,A,I3,I3,A,I3,I3,A,D10.3,A,D10.3,A)
               else if (errtem.lt.errcur(ivar)) then
                  write(*,701) 'add ', modtype(ivar,modn(ivar)),' ',mo
     *              dv(ivar,modn(ivar),1),modv(ivar,modn(ivar),2),' (ir1
     *              /2=',ir1,ir2,')  err=',errtem,' < ',errcur(ivar)
 701              format(A,I3,A,I3,I3,A,I3,I3,A,D10.3,A,D10.3)
               else
                  write(*,702) 'add ', modtype(ivar,modn(ivar)),' ',mo
     *              dv(ivar,modn(ivar),1),modv(ivar,modn(ivar),2),' (ir1
     *              /2=',ir1,ir2,')  err=',errtem
 702              format(A,I3,A,I3,I3,A,I3,I3,A,D10.3)
               endif
            endif
            if (addterm.gt.0.and.debug.gt.0) then
               if (errtem.lt.errcur(ivar).and.errtem.lt.errbes) then
                  write(*,800) 'add var ',addedvar,' to term ',addterm
     *              ,' (ir1/2=',ir1,ir2,') err=',errtem,' < ',errcur(iva
     *              r),' *'
 800              format(A,I3,A,I3,A,I3,I3,A,D10.3,A,D10.3,A)
               else if (errtem.lt.errcur(ivar)) then
                  write(*,801) 'add var ',addedvar,' to term ',addterm
     *              ,' (ir1/2=',ir1,ir2,') err=',errtem,' < ',errcur(iva
     *              r)
 801              format(A,I3,A,I3,A,I3,I3,A,D10.3,A,D10.3)
               else
                  write(*,802) 'add var ',addedvar,' to term ',addterm
     *              ,' (ir1/2=',ir1,ir2,') err=',errtem
 802              format(A,I3,A,I3,A,I3,I3,A,D10.3)
               endif
            else if (.not.add.and.debug.gt.0) then
            endif
            if (.not.add.and.addterm.eq.0.and.debug.gt.0) then
               write(*,703) 'estvarrm, ir1/2=',ir1,',',ir2,' e=',errte
     *           m
 703           format(A,I3,A,I3,A,D10.3)
            endif
            if (errtem.lt.errcur(ivar).and.errtem.lt.errbes) then
               errbes=errtem 
               ! Make a temporary copy
               call icopy(maxvar*maxr,modtype,1,t2modtype,1)
               call dcopy(maxvar*maxr*maxk*3,modk,1,t2modk,1)
               call icopy(maxvar,modn,1,t2modn,1)
               call icopy(maxvar*maxr*maxv,modv,1,t2modv,1)
            endif
 300        continue 
            ! go to when continueing the reaction loop,
            ! go to next pair ir1,ir2
            call icopy(maxvar*maxr,tmodtype,1,modtype,1) ! Reset
            call dcopy(maxvar*maxr*maxk*3,tmodk,1,modk,1)
            call icopy(maxvar,tmodn,1,modn,1)
            call icopy(maxvar*maxr*maxv,tmodv,1,modv,1)
 500     enddo
 600  enddo
      if (errbes.lt.errloc) then
         ! Set best model
         call icopy(maxvar*maxr,t2modtype,1,modtype,1)
         call dcopy(maxvar*maxr*maxk*3,t2modk,1,modk,1)
         call icopy(maxvar,t2modn,1,modn,1)
         call icopy(maxvar*maxr*maxv,t2modv,1,modv,1)
      endif
      end

C     Remove variable i from reaction number j of variable ivar
C     Requires a GMA term, o.w. nothing happens, isucc=0
C     ivar, variable
C     i, variable index
C     j, reaction number
C     isucc, OUTPUT
C            1=success, 0=no success (e.g. not a GMA term)
      subroutine rmv(maxvar,maxr,maxv,maxk,nvar,
     *     modtype,modk,modn,modv,dependent,
     *     ivar,i,j,isucc)
      implicit none
      integer maxvar,maxr,maxv,maxk,nvar
C     ------------- BEGIN MODEL DEFINITION -------------------------
      integer modtype(maxvar,maxr)
C     Type of reaction [1...maxr] for variable [1...maxvar]
      
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=2: LB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=3: UB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
      
      integer modn(maxvar)
C     Number of reactions for variable [1...maxvar]
      
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      
      logical dependent(maxvar)
C     Which variables are dependent
C     ------------- END MODEL DEFINITION -------------------------
      integer ivar,i,j,isucc,ik,iv,ireact
      isucc=0
      return
      isucc=1
      end

C     Remove reaction number i from variable ivar
C     isucc 1=success, 0=no success OUTPUT
      subroutine rm(maxvar,maxr,maxv,maxk,nvar,
     *     modtype,modk,modn,modv,dependent,
     *     ivar,i,isucc)
      implicit none
      integer maxvar,maxr,maxv,maxk,nvar
C     ------------- BEGIN MODEL DEFINITION -------------------------
      integer modtype(maxvar,maxr)
C     Type of reaction [1...maxr] for variable [1...maxvar]
      
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=2: LB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=3: UB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
      
      integer modn(maxvar)
C     Number of reactions for variable [1...maxvar]
      
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      
      logical dependent(maxvar)
C     Which variables are dependent
C     ------------- END MODEL DEFINITION -------------------------
      integer ivar,i,isucc,ik,iv,ireact
      if (modn(ivar).gt.0) then
         do 100 ireact=i+1,modn(ivar)
            modtype(ivar,ireact-1)=modtype(ivar,ireact)
           do 30 iv=1,maxv
               modv(ivar,ireact-1,iv)=modv(ivar,ireact,iv)
 30        enddo
           do 60 ik=1,maxk
              modk(ivar,ireact-1,ik,1)=modk(ivar,ireact,ik,1)
              modk(ivar,ireact-1,ik,2)=modk(ivar,ireact,ik,2)
              modk(ivar,ireact-1,ik,3)=modk(ivar,ireact,ik,3)
 60         enddo
 100      continue
         modn(ivar)=modn(ivar)-1
         isucc=1
      else
         isucc=0
      endif
      end

C     Add variable i to reaction number j of variable ivar
C     Requires a GMA term, o.w. nothing happens, isucc=0
C     ivar, variable
C     rlisttype(maxvar,maxirl), table of possible reaction types to add
C     rlistv(maxvar,maxirl,maxv), table of vars to each reaction 
C     rlistk(maxvar,maxirl,maxk,2), table of param bounds to each reaction
C     maxirl, max rows in rlist
C     i, variable index
C     j, reaction number
C     isucc, OUTPUT
C            0=success, -1=no success (e.g. not a GMA term)
      subroutine addv(nvar,ivar,rlisttype,rlistv,rlistk,maxirl,
     *     i,j,debug,isucc)
      implicit none
      integer maxexp,maxvar,maxpts,maxr,maxv,maxk
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)
      integer nvar
C     ------------- BEGIN MODEL DEFINITION -------------------------
      integer modtype(maxvar,maxr)
C     Type of reaction [1...maxr] for variable [1...maxvar]
      
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=2: LB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=3: UB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
      
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      
      integer modn(maxvar)
C     Number of reactions for variable [1...maxvar]
      
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      
      logical dependent(maxvar)
C     Which variables are dependent
C     ------------- END MODEL DEFINITION -------------------------
      integer ivar,debug,isucc
      integer maxirl
      integer rlisttype(maxvar,maxirl)
      integer rlistv(maxvar,maxirl,maxv)
      double precision rlistk(maxvar,maxirl,maxk,2)
      integer i,j,ireact
      integer itype,nvs,nks,getVsOfType,getKsOfType,iv,ir,jj,ik
      logical inmodel
      double precision value,lb,ub
      integer vs(maxv),irl
      common/mydata3/modk,modkinit,modn,modv,modtype,dependent
      isucc=-1
      if(i.gt.nvar.or.i.le.0) then
      ! index must be in [1,nvar]
         return
      endif
      return
      itype=modtype(ivar,j)
      do 100, irl=1,maxirl   ! max rows in rlist
         if (rlisttype(ivar,irl).eq.itype) then
            lb=rlistk(ivar,irl,ik,1)
            ub=rlistk(ivar,irl,ik,2)
         endif
 100  continue
      call getInitialValue(itype,ik, !set new parameter value
     *        lb,ub,value)
      modk(ivar,j,ik,1)=value
      modk(ivar,j,ik,2)=lb
      modk(ivar,j,ik,3)=ub
      isucc=0
      end

C     Add reaction i from table rlist to variable ivar
C     rlisttype(maxvar,maxirl), table of possible reaction types to add
C     rlistv(maxvar,maxirl,maxv), table of vars to each reaction 
C     rlistk(maxvar,maxirl,maxk,2), table of param bounds to each reaction
C     maxirl, max rows in rlist
C     isucc, OUTPUT
C            0=success, -1=no success
      subroutine addr(nvar,ivar,
     *     rlisttype,rlistv,rlistk,maxirl,i,
     *     debug,isucc)
      implicit none
      integer maxexp,maxvar,maxpts,maxr,maxv,maxk
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)
      integer nvar
C     ------------- BEGIN MODEL DEFINITION -------------------------
      integer modtype(maxvar,maxr)
C     Type of reaction [1...maxr] for variable [1...maxvar]
      
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=2: LB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
C     Last index=3: UB for param. [1...maxk] for reaction [1...maxr] in var. [1...maxvar]
      
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      
      integer modn(maxvar)
C     Number of reactions for variable [1...maxvar]
      
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      
      logical dependent(maxvar)
C     Which variables are dependent
C     ------------- END MODEL DEFINITION -------------------------
      integer ivar,debug,isucc
      integer maxirl 
      integer rlisttype(maxvar,maxirl) 
      integer rlistv(maxvar,maxirl,maxv) 
      double precision rlistk(maxvar,maxirl,maxk,2)
      integer i,ireact
      integer itype,nvs,nks,iv,jj,ik,getVsOfType,getKsOfType
      logical inmodel
      double precision value
      common/mydata3/modk,modkinit,modn,modv,modtype,dependent
      itype=rlisttype(ivar,i)
      nvs=getVsOfType(itype)
      nks=getKsOfType(itype)
      if (modn(ivar).ge.maxr) then
         isucc=-1
         write(*,*) 'add ',itype,' ',
     *        (rlistv(ivar,i,jj),jj=1,nvs),
     *        ' maxr = ',maxr,' reached'
         stop
         return
      endif
      do 100 ireact=1,modn(ivar)
         if (rlisttype(ivar,i).eq.modtype(ivar,ireact)) then
            inmodel=.true.
            do 90 iv=1,getVsOfType(rlisttype(ivar,i))
              if (rlistv(ivar,i,iv).ne.modv(ivar,ireact,iv)) then 
                  inmodel=.false.
              endif
 90         enddo
            if (inmodel) then
	             if (debug.gt.0) write(*,*) 'add ',itype,' ',
     *              (rlistv(ivar,i,jj),jj=1,nvs),
     *              ' already in model'
              isucc=-1
              return
            endif
         endif
 100  enddo
      do 200 ik=1,nks
         call getInitialValue(itype,ik,
     *         rlistk(ivar,i,ik,1),rlistk(ivar,i,ik,2),value)
         modk(ivar,modn(ivar)+1,ik,1)=value
         modk(ivar,modn(ivar)+1,ik,2)=rlistk(ivar,i,ik,1)
         modk(ivar,modn(ivar)+1,ik,3)=rlistk(ivar,i,ik,2)
 200  enddo
      do 300 iv=1,nvs
         modv(ivar,modn(ivar)+1,iv)=rlistv(ivar,i,iv)
 300  enddo 
      do 400 iv=nvs+1,maxv       ! Set potential remaining positions to zero
         modv(ivar,modn(ivar)+1,iv)=0
 400  enddo 
      modtype(ivar,modn(ivar)+1)=itype
      modn(ivar)=modn(ivar)+1
      isucc=0
      return
      end
