C     This file was automatically generated by GenerateFortran.generate()
C     on Wed Feb 06 14:05:22 CET 2013
C
C    Odeidon, a program for structural identification of ODEs
C    Copyright (C) 2011 Peter Gennemark, Dag Wedelin
C
C    This program is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.

C    You should have received a copy of the GNU General Public License
C    along with this program.  If not, see <http://www.gnu.org/licenses/>.

C    Contact: Peter Gennemark, Dag Wedelin
C             www.odeidentification.org
C
C
C
C     Simulate model
C     nvar - no of variables
C     nexp - no experiments
C     nvare- no variables in experiments including time at index 1
C     npts - no points in experiment
C     edata - exp data
C     sdata - simulated data OUT
C     iexp - exp to simualate
C     istate - state of simulation (<0 indicates error) OUT
      subroutine simulatesingle(nvar,
     *     modtype,modk,modkinit,modn,modv,dependent,
     *     nexp,nvare,npts,
     *     edata,sdata,spline,
     *     iexp,
     *     istate,
     *     ivar,
     *     edata2,npts2,useip)
      
      implicit none
      integer nvar,nexp,ivar,ivar2
      integer maxexp,maxvar,maxpts,maxr,maxv,maxk
      parameter (maxexp=4,maxvar=5,maxpts=201,maxr=10,maxv=2,maxk=1)

      
C     ------ MODEL ------
      integer modtype(maxvar,maxr) 
C     Type of reaction [1...maxr] for variable [1...maxvar]
      double precision modk(maxvar,maxr,maxk,3) 
C     Last index=1: Parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=2: Lower bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
C     Last index=3: Upper bound for parameter [1...maxk] for reaction [1...maxr] in variable [1...maxvar]
      double precision modkinit(maxexp,maxvar,3) 
C     Last index=1: Init conc for experiment [1...maxexp], variable [1...maxvar]
C     Last index=2: Lower bound for experiment [1...maxexp], variable [1...maxvar]
C     Last index=3: Upper bound for experiment [1...maxexp], variable [1...maxvar]
      integer modn(maxvar) 
C     Number of reactions for variable [1...maxvar]
      integer modv(maxvar,maxr,maxv)
C     Variable [1...maxv] for reaction [1...maxr] in variable [1...maxvar]
      logical dependent(maxvar) 
C     Which variables are dependent


      integer nvare,npts,npts2    
      double precision edata(maxexp,maxvar+1,2*maxpts)
      double precision edata2(maxexp,maxvar+1,2*maxpts)
      double precision sdata(maxexp,maxvar+1,2*maxpts)
      integer spline(maxexp,maxvar) ! 0=linear interpolation, 1=cubic smoothing spline 
         
      external modelsingle, jac  
      integer iexp,iexp2,i,j,k,ireact

      integer  iopt, iout, istate, itask, itol, liw, lrw
      parameter (lrw=32)       ! 22+9maxvar+maxvar**2
      parameter (liw=21)        ! 20+maxvar
      integer  mf,neq,iwork(liw)
      double precision  atol, rtol, rwork(lrw),t,tout, y(1)
      double precision  ytemp,y0(1)
      
      logical debug,useip(maxvar)
     

      common/simuls/ivar2,iexp2        ! communicates with subroutine model 
      
      debug=.false.

      if (nvar.ne.nvare) then   ! check parameters nvar and nvare
         write(*,*) 'simulatesingle, nvar=',nvar,' nvare=',nvare
         stop
      endif
      
      if (iexp.lt.1.or.iexp.gt.nexp) then ! check parameter iexp
         write(*,*) 'simulatesingle, error exp=',iexp
         return
      endif
     
      
      ivar2=ivar                ! make copies
      iexp2=iexp               
      

C     Initial values
      y(1)=modkinit(iexp,ivar,1) 
      if (debug) write(*,*) 'y0=',y(1)

      neq = 1
      itol = 1
      rtol = 1.D-4
      atol = 1.D-10
      itask = 1
      iopt = 0
      mf = 22 ! 21 for jacobian supplied
            
c$$$      iopt=1
c$$$      iwork(5)=0
c$$$      iwork(6)=0 
c$$$      iwork(7)=0
c$$$      iwork(8)=0
c$$$      iwork(9)=0
c$$$      iwork(10)=0
c$$$      rwork(5)=0.0
c$$$      !rwork(6)=1.0 ! hmax
c$$$      rwork(7)=0.0
c$$$      rwork(8)=0.0
c$$$      rwork(9)=0.0
c$$$      rwork(10)=0.0

C     simulate
      t = edata(iexp,1,1)
      istate = 1
      do 140 iout = 1,npts
         tout = edata(iexp,1,iout)
         call dlsode (modelsingle, neq, y, t, tout, itol, rtol, atol, 
     *        itask,istate, iopt, rwork, lrw, iwork, liw, jac, mf)
         if (debug) write(*,*) 'simulatesingle, t=',t,' y=',y(1)
          sdata(iexp,1,iout)=t
          sdata(iexp,(ivar+1),iout)=y(1)
         if (istate.lt. 0)  go to 180
 140   continue 
      if (debug) write(*,160)  iwork(11), iwork(12), iwork(13)
 160   format(/'# No. steps =',i4,',No. f-s =',i4,',No. J-s =',i4)
      return
 180   if (debug) write(*,190)  istate
 190   format('dlsode, error halt. ISTATE =',I3)
      end 






      

