/** 
    ODEidon, a program for structural identification of ODEs
    Copyright (C) 2011 Peter Gennemark, Dag Wedelin

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact: Peter Gennemark, Dag Wedelin
             www.odeidentification.org
*/

package Java;

import Java.generateFortran.*;
import Java.problem.*;
import Java.debug.*;
import java.io.*;


/**
 * Generate Fortran program to solve problem given as argv[0]
 * @author      Peter Gennemark, www.odeidentification.org
 * @version     1.0                   
 * @since       1.0
 */

public class GenerateProgram {
        

/**
 * Generate Fortran program to solve problem given as argv[0]
 * @param argv array of Strings, first item contains path to problem file
 */
    public static void main(String[] argv){ 
        if (argv.length==0){
	   Debug.staterror("GenerateProgram","main","Input problem file required.");
        }
	Debug.ON = false;
	Debug.ERROR = true;
	Debug.WARNING = true;
	String filetree = System.getProperty("user.dir") + 
	    System.getProperty("file.separator");
	File file=new File(filetree+argv[0]);
	if (file==null){
	    Debug.staterror("GenerateProgram","main","Input problem file not found.");
	}
	Problem p=new Problem();
	p.read(file,1); 
	GenerateFortran gf = new GenerateFortran("F_generatedCode"+
						 System.getProperty("file.separator"),
						 p);
	Debug.stat("GenerateFortran","main","Code for problem "+argv[0]+
		   " is generated in directory F_generatedCode.");
    }
        
}
