/** 
    ODEidon, a program for structural identification of ODEs
    Copyright (C) 2011 Peter Gennemark, Dag Wedelin

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact: Peter Gennemark, Dag Wedelin
             www.odeidentification.org
*/


package Java;

import java.io.*;
import Java.debug.*;
import Java.problem.*;



/**
 * Verify syntax of a problem
 * @author      Peter Gennemark, www.odeidentification.org
 * @version     1.0                   
 * @since       1.0
 */
public class VerifyProblem {
  

/**
 * Verify syntax of a problem given as argv[0]
 * Print out debug information by adding a second argument "-d" to argv[1],
 * e.g., java VerifyProblem problemFile -d
 * @param argv array of Strings, first item contains path to problem file, 2nd argument is optional and can contain "-d" for debug information
 */
  public static void main(String[] argv){  
    if (argv.length==0){
	Debug.error("VerifyProblem","main","Input problem file required.");
    }
    int debugLevel=0;
    if (argv.length==1){
	debugLevel=0;
    }
    if (argv.length==2 && argv[1].equals("-d")){
	debugLevel=1;
    }
    String filetree = System.getProperty("user.dir") + 
      System.getProperty("file.separator");
    File file=new File(filetree+argv[0]);
    if (file==null){
	Debug.error("VerifyProblem","main","Input problem file not found.");
    }
    Problem p=new Problem();
    p.read(file,debugLevel);
  }

}


