/** 
    ODEidon, a program for structural identification of ODEs
    Copyright (C) 2011 Peter Gennemark, Dag Wedelin

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact: Peter Gennemark, Dag Wedelin
             www.odeidentification.org
*/


package Java.gui;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import Java.debug.*;


/** Panel for two column dialogs: left: input description, right input fields
 * @author      Peter Gennemark, www.odeidentification.org
 * @version     1.0                   
 * @since       1.0
 */
public class AlignedInputPanel extends JPanel {
  GridBagLayout gbl = new GridBagLayout();
  GridBagConstraints gbc = new GridBagConstraints();
  int line = 0;
  
  public AlignedInputPanel() {
    setLayout(gbl);
    gbc.weightx = 1.0;
    gbc.weighty = 1.0;
    gbc.gridheight = 1;
  }
  
  /** Add one line to the panel
      @param header description
      @param comp the input component
  */
  public void addLine(String header, JComponent comp) {
    gbc.gridy = line++;
    gbc.gridx = 0;
    gbc.gridwidth = 1;
    gbc.weightx = 0.0;
    gbc.anchor = GridBagConstraints.WEST;
    gbc.fill = GridBagConstraints.NONE;    
    JLabel label = new JLabel(header, JLabel.LEFT);
    gbl.setConstraints(label, gbc);
    add(label);
    gbc.gridx = GridBagConstraints.RELATIVE;
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbc.weightx = 1.0;
    gbc.anchor = GridBagConstraints.CENTER;
    gbc.fill = GridBagConstraints.HORIZONTAL;    
    gbl.setConstraints(comp, gbc);
    add(comp);    
    comp.setBorder(new CompoundBorder(new EmptyBorder(2, 0, 2, 0), comp.getBorder()));
  }
}
