/** 
    ODEidon, a program for structural identification of ODEs
    Copyright (C) 2011 Peter Gennemark, Dag Wedelin

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact: Peter Gennemark, Dag Wedelin
             www.odeidentification.org
*/

package Java.gui;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import Java.debug.*;

/**
 * Set up the dialog for the axes settings
 * @author      Peter Gennemark, www.odeidentification.org
 * @version     1.0                   
 * @since       1.0
 */
public class SetAxesDialog {

  JTextField xmin,xmax,ymin,ymax;
  JCheckBox default_axes;
  
  AlignedInputPanel panel = new AlignedInputPanel();
  
  public SetAxesDialog() {
    panel.addLine("Use default axes: ", default_axes = new JCheckBox()); 
    panel.addLine("X min: ", xmin = new JTextField()); 
    panel.addLine("X max: ", xmax = new JTextField()); 
    panel.addLine("Y min: ", ymin = new JTextField()); 
    panel.addLine("Y max: ", ymax = new JTextField());  
    

    
    default_axes.addActionListener(new ActionListener() {    
      public void actionPerformed(ActionEvent e) { 
	if (default_axes.isSelected()){
	  xmin.setEnabled(false);
	  xmax.setEnabled(false);
	  ymin.setEnabled(false);
	  ymax.setEnabled(false);
	}
	else {
	  xmin.setEnabled(true);
	  xmax.setEnabled(true);
	  ymin.setEnabled(true);
	  ymax.setEnabled(true);
	}
      }
    });


  
  }  
  
  
}
   
